searchData={"items":[{"type":"module","title":"Hermes.CLI","doc":"CLI entry point for the Hermes MCP standalone binary.\n\nThis module serves as the main entry point when the application is built \nas a standalone binary with Burrito. It delegates to the Mix.Interactive.CLI\nmodule for the actual CLI implementation.","ref":"Hermes.CLI.html"},{"type":"function","title":"Hermes.CLI.main/0","doc":"Main entry point for the standalone CLI application.","ref":"Hermes.CLI.html#main/0"},{"type":"module","title":"Hermes.Client","doc":"A GenServer implementation of an MCP (Model Context Protocol) client.\n\nThis module handles the client-side implementation of the MCP protocol,\nincluding initialization, request/response handling, and maintaining\nprotocol state.\n\n>","ref":"Hermes.Client.html"},{"type":"module","title":"Notes {: .info} - Hermes.Client","doc":">\n> For initialization and setup, check our [Installation & Setup](./installation.html) and\n> the [Client Usage](./client_usage.html) guides for reference.","ref":"Hermes.Client.html#module-notes-info"},{"type":"function","title":"Hermes.Client.call_tool/4","doc":"Calls a tool on the server.","ref":"Hermes.Client.html#call_tool/4"},{"type":"function","title":"Options - Hermes.Client.call_tool/4","doc":"* `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#call_tool/4-options"},{"type":"function","title":"Hermes.Client.cancel_all_requests/3","doc":"Cancels all pending requests.","ref":"Hermes.Client.html#cancel_all_requests/3"},{"type":"function","title":"Parameters - Hermes.Client.cancel_all_requests/3","doc":"* `client` - The client process\n  * `reason` - Optional reason for cancellation (defaults to \"client_cancelled\")","ref":"Hermes.Client.html#cancel_all_requests/3-parameters"},{"type":"function","title":"Returns - Hermes.Client.cancel_all_requests/3","doc":"* `{:ok, requests}` - A list of the Request structs that were cancelled\n  * `{:error, reason}` - If an error occurred","ref":"Hermes.Client.html#cancel_all_requests/3-returns"},{"type":"function","title":"Hermes.Client.cancel_request/4","doc":"Cancels an in-progress request.","ref":"Hermes.Client.html#cancel_request/4"},{"type":"function","title":"Parameters - Hermes.Client.cancel_request/4","doc":"* `client` - The client process\n  * `request_id` - The ID of the request to cancel\n  * `reason` - Optional reason for cancellation","ref":"Hermes.Client.html#cancel_request/4-parameters"},{"type":"function","title":"Returns - Hermes.Client.cancel_request/4","doc":"* `:ok` if the cancellation was successful\n  * `{:error, reason}` if an error occurred\n  * `{:not_found, request_id}` if the request ID was not found","ref":"Hermes.Client.html#cancel_request/4-returns"},{"type":"type","title":"Hermes.Client.capabilities/0","doc":"MCP client capabilities\n\n- `:roots` - Capabilities related to the roots resource\n  - `:listChanged` - Whether the client can handle listChanged notifications\n- `:sampling` - Capabilities related to sampling\n\nMCP describes these client capabilities on it [specification](https://spec.modelcontextprotocol.io/specification/2024-11-05/client/)","ref":"Hermes.Client.html#t:capabilities/0"},{"type":"function","title":"Hermes.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hermes.Client.html#child_spec/1"},{"type":"type","title":"Hermes.Client.client_info/0","doc":"MCP client metadata info\n\n- `:name` - The name of the client (required)\n- `:version` - The version of the client","ref":"Hermes.Client.html#t:client_info/0"},{"type":"function","title":"Hermes.Client.close/1","doc":"Closes the client connection and terminates the process.","ref":"Hermes.Client.html#close/1"},{"type":"function","title":"Hermes.Client.get_prompt/4","doc":"Gets a specific prompt from the server.","ref":"Hermes.Client.html#get_prompt/4"},{"type":"function","title":"Options - Hermes.Client.get_prompt/4","doc":"* `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#get_prompt/4-options"},{"type":"function","title":"Hermes.Client.get_schema/1","doc":"","ref":"Hermes.Client.html#get_schema/1"},{"type":"function","title":"Hermes.Client.get_server_capabilities/2","doc":"Gets the server's capabilities as reported during initialization.\n\nReturns `nil` if the client has not been initialized yet.","ref":"Hermes.Client.html#get_server_capabilities/2"},{"type":"function","title":"Hermes.Client.get_server_info/2","doc":"Gets the server's information as reported during initialization.\n\nReturns `nil` if the client has not been initialized yet.","ref":"Hermes.Client.html#get_server_info/2"},{"type":"function","title":"Hermes.Client.list_prompts/2","doc":"Lists available prompts from the server.","ref":"Hermes.Client.html#list_prompts/2"},{"type":"function","title":"Options - Hermes.Client.list_prompts/2","doc":"* `:cursor` - Pagination cursor for continuing a previous request\n  * `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#list_prompts/2-options"},{"type":"function","title":"Hermes.Client.list_resources/2","doc":"Lists available resources from the server.","ref":"Hermes.Client.html#list_resources/2"},{"type":"function","title":"Options - Hermes.Client.list_resources/2","doc":"* `:cursor` - Pagination cursor for continuing a previous request\n  * `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#list_resources/2-options"},{"type":"function","title":"Hermes.Client.list_tools/2","doc":"Lists available tools from the server.","ref":"Hermes.Client.html#list_tools/2"},{"type":"function","title":"Options - Hermes.Client.list_tools/2","doc":"* `:cursor` - Pagination cursor for continuing a previous request\n  * `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#list_tools/2-options"},{"type":"function","title":"Hermes.Client.merge_capabilities/3","doc":"Merges additional capabilities into the client's capabilities.","ref":"Hermes.Client.html#merge_capabilities/3"},{"type":"type","title":"Hermes.Client.option/0","doc":"MCP client initialization options\n\n- `:name` - Following the `GenServer` patterns described on \"Name registration\".\n- `:transport` - The MCP transport options\n- `:client_info` - Information about the client\n- `:capabilities` - Client capabilities to advertise to the MCP server\n- `:protocol_version` - Protocol version to use (defaults to \"2024-11-05\")\n\nAny other option support by `GenServer`.","ref":"Hermes.Client.html#t:option/0"},{"type":"function","title":"Hermes.Client.parse_options/1","doc":"","ref":"Hermes.Client.html#parse_options/1"},{"type":"function","title":"Hermes.Client.parse_options!/1","doc":"","ref":"Hermes.Client.html#parse_options!/1"},{"type":"function","title":"Hermes.Client.ping/2","doc":"Sends a ping request to the server to check connection health. Returns `:pong` if successful.","ref":"Hermes.Client.html#ping/2"},{"type":"function","title":"Options - Hermes.Client.ping/2","doc":"* `:timeout` - Request timeout in milliseconds (default: 30s)\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#ping/2-options"},{"type":"function","title":"Hermes.Client.read_resource/3","doc":"Reads a specific resource from the server.","ref":"Hermes.Client.html#read_resource/3"},{"type":"function","title":"Options - Hermes.Client.read_resource/3","doc":"* `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#read_resource/3-options"},{"type":"function","title":"Hermes.Client.register_log_callback/3","doc":"Registers a callback function to be called when log messages are received.","ref":"Hermes.Client.html#register_log_callback/3"},{"type":"function","title":"Parameters - Hermes.Client.register_log_callback/3","doc":"* `client` - The client process\n  * `callback` - A function that takes three arguments: level, data, and logger name\n\nThe callback function will be called whenever a log message notification is received.","ref":"Hermes.Client.html#register_log_callback/3-parameters"},{"type":"function","title":"Hermes.Client.register_progress_callback/4","doc":"Registers a callback function to be called when progress notifications are received\nfor the specified progress token.","ref":"Hermes.Client.html#register_progress_callback/4"},{"type":"function","title":"Parameters - Hermes.Client.register_progress_callback/4","doc":"* `client` - The client process\n  * `progress_token` - The progress token to watch for (string or integer)\n  * `callback` - A function that takes three arguments: progress_token, progress, and total\n\nThe callback function will be called whenever a progress notification with the\nmatching token is received.","ref":"Hermes.Client.html#register_progress_callback/4-parameters"},{"type":"function","title":"Hermes.Client.send_progress/5","doc":"Sends a progress notification to the server for a long-running operation.","ref":"Hermes.Client.html#send_progress/5"},{"type":"function","title":"Parameters - Hermes.Client.send_progress/5","doc":"* `client` - The client process\n  * `progress_token` - The progress token provided in the original request (string or integer)\n  * `progress` - The current progress value (number)\n  * `total` - The optional total value for the operation (number)\n\nReturns `:ok` if notification was sent successfully, or `{:error, reason}` otherwise.","ref":"Hermes.Client.html#send_progress/5-parameters"},{"type":"function","title":"Hermes.Client.set_log_level/2","doc":"Sets the minimum log level for the server to send log messages.","ref":"Hermes.Client.html#set_log_level/2"},{"type":"function","title":"Parameters - Hermes.Client.set_log_level/2","doc":"* `client` - The client process\n  * `level` - The minimum log level (debug, info, notice, warning, error, critical, alert, emergency)\n\nReturns {:ok, result} if successful, {:error, reason} otherwise.","ref":"Hermes.Client.html#set_log_level/2-parameters"},{"type":"function","title":"Hermes.Client.start_link/1","doc":"Starts a new MCP client process.","ref":"Hermes.Client.html#start_link/1"},{"type":"type","title":"Hermes.Client.t/0","doc":"","ref":"Hermes.Client.html#t:t/0"},{"type":"type","title":"Hermes.Client.transport/0","doc":"MCP client transport options\n\n- `:layer` - The transport layer to use, either `Hermes.Transport.STDIO` or `Hermes.Transport.SSE` (required)\n- `:name` - The transport optional custom name","ref":"Hermes.Client.html#t:transport/0"},{"type":"function","title":"Hermes.Client.unregister_log_callback/2","doc":"Unregisters a previously registered log callback.","ref":"Hermes.Client.html#unregister_log_callback/2"},{"type":"function","title":"Parameters - Hermes.Client.unregister_log_callback/2","doc":"* `client` - The client process\n  * `callback` - The callback function to unregister","ref":"Hermes.Client.html#unregister_log_callback/2-parameters"},{"type":"function","title":"Hermes.Client.unregister_progress_callback/3","doc":"Unregisters a previously registered progress callback for the specified token.","ref":"Hermes.Client.html#unregister_progress_callback/3"},{"type":"function","title":"Parameters - Hermes.Client.unregister_progress_callback/3","doc":"* `client` - The client process\n  * `progress_token` - The progress token to stop watching (string or integer)","ref":"Hermes.Client.html#unregister_progress_callback/3-parameters"},{"type":"module","title":"Hermes.Client.Operation","doc":"Represents an operation to be performed by the MCP client.\n\nThis struct encapsulates all information about a client API call:\n- `method` - The MCP method to call\n- `params` - The parameters to send to the server\n- `progress_opts` - Progress tracking options (optional)\n- `timeout` - The timeout for this specific operation (default: 30 seconds)","ref":"Hermes.Client.Operation.html"},{"type":"function","title":"Hermes.Client.Operation.new/1","doc":"Creates a new operation struct.","ref":"Hermes.Client.Operation.html#new/1"},{"type":"function","title":"Parameters - Hermes.Client.Operation.new/1","doc":"* `attrs` - Map containing the operation attributes\n    * `:method` - The MCP method name (required)\n    * `:params` - The parameters to send to the server (required)\n    * `:progress_opts` - Progress tracking options (optional)\n    * `:timeout` - The timeout for this operation in milliseconds (optional, defaults to 30s)","ref":"Hermes.Client.Operation.html#new/1-parameters"},{"type":"type","title":"Hermes.Client.Operation.progress_options/0","doc":"","ref":"Hermes.Client.Operation.html#t:progress_options/0"},{"type":"type","title":"Hermes.Client.Operation.t/0","doc":"","ref":"Hermes.Client.Operation.html#t:t/0"},{"type":"module","title":"Hermes.Client.Request","doc":"Represents a pending request in the MCP client.\n\nThis struct encapsulates all information about an in-progress request:\n- `id` - The unique request ID\n- `method` - The MCP method being called\n- `from` - The GenServer caller reference\n- `timer_ref` - Reference to the request-specific timeout timer\n- `start_time` - When the request started (monotonic time in milliseconds)","ref":"Hermes.Client.Request.html"},{"type":"function","title":"Hermes.Client.Request.elapsed_time/1","doc":"Calculates the elapsed time for a request in milliseconds.","ref":"Hermes.Client.Request.html#elapsed_time/1"},{"type":"function","title":"Hermes.Client.Request.new/1","doc":"Creates a new request struct.","ref":"Hermes.Client.Request.html#new/1"},{"type":"function","title":"Parameters - Hermes.Client.Request.new/1","doc":"* `attrs` - Map containing the request attributes\n    * `:id` - The unique request ID\n    * `:method` - The MCP method name\n    * `:from` - The GenServer caller reference\n    * `:timer_ref` - Reference to the request-specific timeout timer","ref":"Hermes.Client.Request.html#new/1-parameters"},{"type":"type","title":"Hermes.Client.Request.t/0","doc":"","ref":"Hermes.Client.Request.html#t:t/0"},{"type":"module","title":"Hermes.Client.State","doc":"Manages state for the Hermes MCP client.\n\nThis module provides a structured representation of client state,\nincluding capabilities, server info, and request tracking.","ref":"Hermes.Client.State.html"},{"type":"module","title":"State Structure - Hermes.Client.State","doc":"Each client state includes:\n- `client_info`: Information about the client\n- `capabilities`: Client capabilities\n- `server_capabilities`: Server capabilities received during initialization\n- `server_info`: Server information received during initialization\n- `protocol_version`: MCP protocol version being used\n- `request_timeout`: Default timeout for requests\n- `transport`: Transport module or transport info\n- `pending_requests`: Map of pending requests with details and timers\n- `progress_callbacks`: Map of callbacks for progress tracking\n- `log_callback`: Callback for handling log messages","ref":"Hermes.Client.State.html#module-state-structure"},{"type":"module","title":"Examples - Hermes.Client.State","doc":"```elixir\n# Create a new client state\nstate = Hermes.Client.State.new(%{\n  client_info: %{\"name\" => \"MyClient\", \"version\" => \"1.0.0\"},\n  capabilities: %{\"resources\" => %{}},\n  protocol_version: \"2024-11-05\",\n  request_timeout: 30000,\n  transport: %{layer: Hermes.Transport.SSE, name: MyTransport}\n})\n\n# Add a request to the state\n{request_id, updated_state} = Hermes.Client.State.add_request(state, \"ping\", %{}, from)\n\n# Get server capabilities\nserver_capabilities = Hermes.Client.State.get_server_capabilities(state)\n```","ref":"Hermes.Client.State.html#module-examples"},{"type":"function","title":"Hermes.Client.State.add_progress_token_to_params/2","doc":"Helper function to add progress token to params if provided.","ref":"Hermes.Client.State.html#add_progress_token_to_params/2"},{"type":"function","title":"Hermes.Client.State.add_request_from_operation/3","doc":"Adds a new request to the state from an Operation and returns the request ID and updated state.\n\nThis function:\n1. Processes the operation details\n2. Creates a new request with a unique ID\n3. Sets up the timeout timer\n4. Registers any progress callbacks\n5. Updates the state with the new request","ref":"Hermes.Client.State.html#add_request_from_operation/3"},{"type":"function","title":"Parameters - Hermes.Client.State.add_request_from_operation/3","doc":"* `state` - The current client state\n  * `operation` - The operation to perform\n  * `from` - The GenServer.from for the caller","ref":"Hermes.Client.State.html#add_request_from_operation/3-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.add_request_from_operation/3","doc":"iex> operation = Operation.new(%{method: \"ping\", params: %{}})\n    iex> {req_id, updated_state} = Hermes.Client.State.add_request_from_operation(state, operation, {pid, ref})\n    iex> is_binary(req_id)\n    true\n    iex> map_size(updated_state.pending_requests) > map_size(state.pending_requests)\n    true","ref":"Hermes.Client.State.html#add_request_from_operation/3-examples"},{"type":"function","title":"Hermes.Client.State.clear_log_callback/1","doc":"Clears the log callback.","ref":"Hermes.Client.State.html#clear_log_callback/1"},{"type":"function","title":"Parameters - Hermes.Client.State.clear_log_callback/1","doc":"* `state` - The current client state","ref":"Hermes.Client.State.html#clear_log_callback/1-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.clear_log_callback/1","doc":"iex> updated_state = Hermes.Client.State.clear_log_callback(state)\n    iex> is_nil(updated_state.log_callback)\n    true","ref":"Hermes.Client.State.html#clear_log_callback/1-examples"},{"type":"function","title":"Hermes.Client.State.get_log_callback/1","doc":"Gets the log callback.","ref":"Hermes.Client.State.html#get_log_callback/1"},{"type":"function","title":"Parameters - Hermes.Client.State.get_log_callback/1","doc":"* `state` - The current client state","ref":"Hermes.Client.State.html#get_log_callback/1-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.get_log_callback/1","doc":"iex> callback = Hermes.Client.State.get_log_callback(state)\n    iex> is_function(callback, 3) or is_nil(callback)\n    true","ref":"Hermes.Client.State.html#get_log_callback/1-examples"},{"type":"function","title":"Hermes.Client.State.get_progress_callback/2","doc":"Gets a progress callback for a token.","ref":"Hermes.Client.State.html#get_progress_callback/2"},{"type":"function","title":"Parameters - Hermes.Client.State.get_progress_callback/2","doc":"* `state` - The current client state\n  * `token` - The progress token to get the callback for","ref":"Hermes.Client.State.html#get_progress_callback/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.get_progress_callback/2","doc":"iex> callback = Hermes.Client.State.get_progress_callback(state, \"token123\")\n    iex> is_function(callback, 3)\n    true","ref":"Hermes.Client.State.html#get_progress_callback/2-examples"},{"type":"function","title":"Hermes.Client.State.get_request/2","doc":"Gets a request by ID.","ref":"Hermes.Client.State.html#get_request/2"},{"type":"function","title":"Parameters - Hermes.Client.State.get_request/2","doc":"* `state` - The current client state\n  * `id` - The request ID to retrieve","ref":"Hermes.Client.State.html#get_request/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.get_request/2","doc":"iex> Hermes.Client.State.get_request(state, \"req_123\")\n    {{pid, ref}, \"ping\", timer_ref, start_time} # or nil if not found","ref":"Hermes.Client.State.html#get_request/2-examples"},{"type":"function","title":"Hermes.Client.State.get_server_capabilities/1","doc":"Gets the server capabilities.","ref":"Hermes.Client.State.html#get_server_capabilities/1"},{"type":"function","title":"Parameters - Hermes.Client.State.get_server_capabilities/1","doc":"* `state` - The current client state","ref":"Hermes.Client.State.html#get_server_capabilities/1-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.get_server_capabilities/1","doc":"iex> Hermes.Client.State.get_server_capabilities(state)\n    %{\"resources\" => %{}, \"tools\" => %{}}","ref":"Hermes.Client.State.html#get_server_capabilities/1-examples"},{"type":"function","title":"Hermes.Client.State.get_server_info/1","doc":"Gets the server info.","ref":"Hermes.Client.State.html#get_server_info/1"},{"type":"function","title":"Parameters - Hermes.Client.State.get_server_info/1","doc":"* `state` - The current client state","ref":"Hermes.Client.State.html#get_server_info/1-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.get_server_info/1","doc":"iex> Hermes.Client.State.get_server_info(state)\n    %{\"name\" => \"TestServer\", \"version\" => \"1.0.0\"}","ref":"Hermes.Client.State.html#get_server_info/1-examples"},{"type":"function","title":"Hermes.Client.State.handle_request_timeout/2","doc":"Handles a request timeout, cancelling the timer and returning the updated state.","ref":"Hermes.Client.State.html#handle_request_timeout/2"},{"type":"function","title":"Parameters - Hermes.Client.State.handle_request_timeout/2","doc":"* `state` - The current client state\n  * `id` - The request ID that timed out","ref":"Hermes.Client.State.html#handle_request_timeout/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.handle_request_timeout/2","doc":"iex> Hermes.Client.State.handle_request_timeout(state, \"req_123\")\n    {%{from: from, method: \"ping\", elapsed_ms: 30000}, updated_state}","ref":"Hermes.Client.State.html#handle_request_timeout/2-examples"},{"type":"function","title":"Hermes.Client.State.list_pending_requests/1","doc":"Returns a list of all pending requests.","ref":"Hermes.Client.State.html#list_pending_requests/1"},{"type":"function","title":"Parameters - Hermes.Client.State.list_pending_requests/1","doc":"* `state` - The current client state","ref":"Hermes.Client.State.html#list_pending_requests/1-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.list_pending_requests/1","doc":"iex> requests = Hermes.Client.State.list_pending_requests(state)\n    iex> length(requests) > 0\n    true\n    iex> hd(requests).method\n    \"ping\"","ref":"Hermes.Client.State.html#list_pending_requests/1-examples"},{"type":"type","title":"Hermes.Client.State.log_callback/0","doc":"","ref":"Hermes.Client.State.html#t:log_callback/0"},{"type":"function","title":"Hermes.Client.State.merge_capabilities/2","doc":"Merges additional capabilities into the client's capabilities.","ref":"Hermes.Client.State.html#merge_capabilities/2"},{"type":"function","title":"Parameters - Hermes.Client.State.merge_capabilities/2","doc":"* `state` - The current client state\n  * `additional_capabilities` - The capabilities to merge","ref":"Hermes.Client.State.html#merge_capabilities/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.merge_capabilities/2","doc":"iex> updated_state = Hermes.Client.State.merge_capabilities(state, %{\"tools\" => %{\"execute\" => true}})\n    iex> updated_state.capabilities[\"tools\"][\"execute\"]\n    true","ref":"Hermes.Client.State.html#merge_capabilities/2-examples"},{"type":"function","title":"Hermes.Client.State.new/1","doc":"Creates a new client state with the given options.","ref":"Hermes.Client.State.html#new/1"},{"type":"function","title":"Parameters - Hermes.Client.State.new/1","doc":"* `opts` - Map containing the initialization options","ref":"Hermes.Client.State.html#new/1-parameters"},{"type":"function","title":"Options - Hermes.Client.State.new/1","doc":"* `:client_info` - Information about the client (required)\n  * `:capabilities` - Client capabilities to advertise\n  * `:protocol_version` - Protocol version to use\n  * `:request_timeout` - Default timeout for requests in milliseconds\n  * `:transport` - Transport configuration","ref":"Hermes.Client.State.html#new/1-options"},{"type":"function","title":"Examples - Hermes.Client.State.new/1","doc":"iex> Hermes.Client.State.new(%{\n    ...>   client_info: %{\"name\" => \"MyClient\", \"version\" => \"1.0.0\"},\n    ...>   capabilities: %{\"resources\" => %{}},\n    ...>   protocol_version: \"2024-11-05\",\n    ...>   transport: %{layer: Hermes.Transport.SSE, name: MyTransport}\n    ...> })\n    %Hermes.Client.State{\n      client_info: %{\"name\" => \"MyClient\", \"version\" => \"1.0.0\"},\n      capabilities: %{\"resources\" => %{}},\n      protocol_version: \"2024-11-05\",\n      transport: %{layer: Hermes.Transport.SSE, name: MyTransport}\n    }","ref":"Hermes.Client.State.html#new/1-examples"},{"type":"type","title":"Hermes.Client.State.progress_callback/0","doc":"","ref":"Hermes.Client.State.html#t:progress_callback/0"},{"type":"function","title":"Hermes.Client.State.register_progress_callback/3","doc":"Registers a progress callback for a token.","ref":"Hermes.Client.State.html#register_progress_callback/3"},{"type":"function","title":"Parameters - Hermes.Client.State.register_progress_callback/3","doc":"* `state` - The current client state\n  * `token` - The progress token to register a callback for\n  * `callback` - The callback function to call when progress updates are received","ref":"Hermes.Client.State.html#register_progress_callback/3-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.register_progress_callback/3","doc":"iex> updated_state = Hermes.Client.State.register_progress_callback(state, \"token123\", fn token, progress, total -> IO.inspect({token, progress, total}) end)\n    iex> Map.has_key?(updated_state.progress_callbacks, \"token123\")\n    true","ref":"Hermes.Client.State.html#register_progress_callback/3-examples"},{"type":"function","title":"Hermes.Client.State.register_progress_callback_from_opts/2","doc":"Helper function to register progress callback from options.","ref":"Hermes.Client.State.html#register_progress_callback_from_opts/2"},{"type":"function","title":"Hermes.Client.State.remove_request/2","doc":"Removes a request and returns its info along with the updated state.","ref":"Hermes.Client.State.html#remove_request/2"},{"type":"function","title":"Parameters - Hermes.Client.State.remove_request/2","doc":"* `state` - The current client state\n  * `id` - The request ID to remove","ref":"Hermes.Client.State.html#remove_request/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.remove_request/2","doc":"iex> {request_info, updated_state} = Hermes.Client.State.remove_request(state, \"req_123\")\n    iex> request_info.method\n    \"ping\"\n    iex> request_info.elapsed_ms > 0\n    true","ref":"Hermes.Client.State.html#remove_request/2-examples"},{"type":"function","title":"Hermes.Client.State.set_log_callback/2","doc":"Sets the log callback.","ref":"Hermes.Client.State.html#set_log_callback/2"},{"type":"function","title":"Parameters - Hermes.Client.State.set_log_callback/2","doc":"* `state` - The current client state\n  * `callback` - The callback function to call when log messages are received","ref":"Hermes.Client.State.html#set_log_callback/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.set_log_callback/2","doc":"iex> updated_state = Hermes.Client.State.set_log_callback(state, fn level, data, logger -> IO.inspect({level, data, logger}) end)\n    iex> is_function(updated_state.log_callback, 3)\n    true","ref":"Hermes.Client.State.html#set_log_callback/2-examples"},{"type":"type","title":"Hermes.Client.State.t/0","doc":"","ref":"Hermes.Client.State.html#t:t/0"},{"type":"function","title":"Hermes.Client.State.unregister_progress_callback/2","doc":"Unregisters a progress callback for a token.","ref":"Hermes.Client.State.html#unregister_progress_callback/2"},{"type":"function","title":"Parameters - Hermes.Client.State.unregister_progress_callback/2","doc":"* `state` - The current client state\n  * `token` - The progress token to unregister the callback for","ref":"Hermes.Client.State.html#unregister_progress_callback/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.unregister_progress_callback/2","doc":"iex> updated_state = Hermes.Client.State.unregister_progress_callback(state, \"token123\")\n    iex> Map.has_key?(updated_state.progress_callbacks, \"token123\")\n    false","ref":"Hermes.Client.State.html#unregister_progress_callback/2-examples"},{"type":"function","title":"Hermes.Client.State.update_server_info/3","doc":"Updates server info and capabilities after initialization.","ref":"Hermes.Client.State.html#update_server_info/3"},{"type":"function","title":"Parameters - Hermes.Client.State.update_server_info/3","doc":"* `state` - The current client state\n  * `server_capabilities` - The server capabilities received from initialization\n  * `server_info` - The server information received from initialization","ref":"Hermes.Client.State.html#update_server_info/3-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.update_server_info/3","doc":"iex> updated_state = Hermes.Client.State.update_server_info(state, %{\"resources\" => %{}}, %{\"name\" => \"TestServer\"})\n    iex> updated_state.server_capabilities\n    %{\"resources\" => %{}}\n    iex> updated_state.server_info\n    %{\"name\" => \"TestServer\"}","ref":"Hermes.Client.State.html#update_server_info/3-examples"},{"type":"function","title":"Hermes.Client.State.validate_capability/2","doc":"Validates if a method is supported by the server's capabilities.","ref":"Hermes.Client.State.html#validate_capability/2"},{"type":"function","title":"Parameters - Hermes.Client.State.validate_capability/2","doc":"* `state` - The current client state\n  * `method` - The method to validate","ref":"Hermes.Client.State.html#validate_capability/2-parameters"},{"type":"function","title":"Returns - Hermes.Client.State.validate_capability/2","doc":"* `:ok` if the method is supported\n  * `{:error, %Hermes.MCP.Error{}}` if the method is not supported","ref":"Hermes.Client.State.html#validate_capability/2-returns"},{"type":"function","title":"Examples - Hermes.Client.State.validate_capability/2","doc":"iex> Hermes.Client.State.validate_capability(state_with_resources, \"resources/list\")\n    :ok\n    \n    iex> {:error, error} = Hermes.Client.State.validate_capability(state_without_tools, \"tools/list\")\n    iex> error.reason\n    :method_not_found","ref":"Hermes.Client.State.html#validate_capability/2-examples"},{"type":"module","title":"Hermes.HTTP","doc":"HTTP utilities.","ref":"Hermes.HTTP.html"},{"type":"function","title":"Hermes.HTTP.build/5","doc":"","ref":"Hermes.HTTP.html#build/5"},{"type":"function","title":"Hermes.HTTP.follow_redirect/2","doc":"","ref":"Hermes.HTTP.html#follow_redirect/2"},{"type":"function","title":"Hermes.HTTP.post/3","doc":"Performs a POST request to the given URL.","ref":"Hermes.HTTP.html#post/3"},{"type":"module","title":"Hermes.Logging","doc":"Centralized logging for Hermes MCP client.\n\nThis module provides structured logging functions that automatically manage context\nand format logs appropriately based on log levels.","ref":"Hermes.Logging.html"},{"type":"function","title":"Hermes.Logging.add_context/1","doc":"Add context to existing metadata for all subsequent logs.","ref":"Hermes.Logging.html#add_context/1"},{"type":"function","title":"Hermes.Logging.client_event/3","doc":"Log client events with structured format.","ref":"Hermes.Logging.html#client_event/3"},{"type":"function","title":"Options - Hermes.Logging.client_event/3","doc":"* metadata - Additional metadata including:\n    * :level - The log level (:debug, :info, :warning, :error, etc.)","ref":"Hermes.Logging.html#client_event/3-options"},{"type":"function","title":"Hermes.Logging.context/1","doc":"Set context for all subsequent logs in the current process.","ref":"Hermes.Logging.html#context/1"},{"type":"function","title":"Hermes.Logging.message/5","doc":"Log protocol messages with automatic formatting and context.","ref":"Hermes.Logging.html#message/5"},{"type":"function","title":"Parameters - Hermes.Logging.message/5","doc":"* direction - \"incoming\" or \"outgoing\"\n  * type - message type (e.g., \"request\", \"response\", \"notification\", \"error\")\n  * id - message ID (can be nil)\n  * data - the message content\n  * metadata - additional metadata to include with level option (:debug, :info, :warning, :error, etc.)","ref":"Hermes.Logging.html#message/5-parameters"},{"type":"function","title":"Hermes.Logging.server_event/3","doc":"Log server events with structured format.","ref":"Hermes.Logging.html#server_event/3"},{"type":"function","title":"Options - Hermes.Logging.server_event/3","doc":"* metadata - Additional metadata including:\n    * :level - The log level (:debug, :info, :warning, :error, etc.)","ref":"Hermes.Logging.html#server_event/3-options"},{"type":"function","title":"Hermes.Logging.transport_event/3","doc":"Log transport events with structured format.","ref":"Hermes.Logging.html#transport_event/3"},{"type":"function","title":"Options - Hermes.Logging.transport_event/3","doc":"* metadata - Additional metadata including:\n    * :level - The log level (:debug, :info, :warning, :error, etc.)","ref":"Hermes.Logging.html#transport_event/3-options"},{"type":"module","title":"Hermes.MCP.Error","doc":"Represents errors in the MCP protocol.\n\nThis module defines standardized error types based on the JSON-RPC 2.0\nerror codes, with additional MCP-specific error reasons.","ref":"Hermes.MCP.Error.html"},{"type":"module","title":"Error Structure - Hermes.MCP.Error","doc":"Each error includes:\n- `code`: Numeric error code (following JSON-RPC 2.0 conventions)\n- `reason`: Atom representing the error type (e.g., `:parse_error`, `:timeout`)\n- `data`: Additional context or metadata about the error","ref":"Hermes.MCP.Error.html#module-error-structure"},{"type":"module","title":"Error Categories - Hermes.MCP.Error","doc":"Errors are categorized into:\n- Standard JSON-RPC errors (parse errors, invalid requests, etc.)\n- Transport errors (connection issues, timeouts)\n- Client errors (request handling issues)\n- Server errors (capability issues, domain errors)","ref":"Hermes.MCP.Error.html#module-error-categories"},{"type":"module","title":"Examples - Hermes.MCP.Error","doc":"```elixir\n# Creating standard RPC errors\nHermes.MCP.Error.parse_error()\n\n# Creating transport errors\nHermes.MCP.Error.transport_error(:connection_refused)\n\n# Creating client errors\nHermes.MCP.Error.client_error(:request_timeout, %{elapsed_ms: 30000})\n\n# Converting from JSON-RPC errors\nHermes.MCP.Error.from_json_rpc(%{\"code\" => -32700, \"message\" => \"Parse error\"})\n```","ref":"Hermes.MCP.Error.html#module-examples"},{"type":"function","title":"Hermes.MCP.Error.client_error/2","doc":"Creates a client-related error.\n\nUsed for errors that occur within the client implementation.","ref":"Hermes.MCP.Error.html#client_error/2"},{"type":"function","title":"Parameters - Hermes.MCP.Error.client_error/2","doc":"* `reason` - Atom representing the specific client error\n  * `data` - Additional error context or metadata","ref":"Hermes.MCP.Error.html#client_error/2-parameters"},{"type":"function","title":"Examples - Hermes.MCP.Error.client_error/2","doc":"iex> Hermes.MCP.Error.client_error(:request_timeout, %{elapsed_ms: 30000})\n    %Hermes.MCP.Error{code: -32000, reason: :request_timeout, data: %{type: :client, elapsed_ms: 30000}}","ref":"Hermes.MCP.Error.html#client_error/2-examples"},{"type":"function","title":"Hermes.MCP.Error.domain_error/1","doc":"Creates a domain-level error from an MCP server response.\n\nUsed for application-level errors returned as valid JSON-RPC responses with `isError: true`.","ref":"Hermes.MCP.Error.html#domain_error/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.domain_error/1","doc":"iex> Hermes.MCP.Error.domain_error(%{\"message\" => \"Resource not found\"})\n    %Hermes.MCP.Error{code: -32000, reason: :domain_error, data: %{\"message\" => \"Resource not found\"}}","ref":"Hermes.MCP.Error.html#domain_error/1-examples"},{"type":"function","title":"Hermes.MCP.Error.from_json_rpc/1","doc":"Converts from a JSON-RPC error object to a Hermes.MCP.Error struct.","ref":"Hermes.MCP.Error.html#from_json_rpc/1"},{"type":"function","title":"Parameters - Hermes.MCP.Error.from_json_rpc/1","doc":"* `error` - A map containing the JSON-RPC error fields","ref":"Hermes.MCP.Error.html#from_json_rpc/1-parameters"},{"type":"function","title":"Examples - Hermes.MCP.Error.from_json_rpc/1","doc":"iex> Hermes.MCP.Error.from_json_rpc(%{\"code\" => -32700, \"message\" => \"Parse error\"})\n    %Hermes.MCP.Error{code: -32700, reason: :parse_error, data: %{original_message: \"Parse error\"}}","ref":"Hermes.MCP.Error.html#from_json_rpc/1-examples"},{"type":"function","title":"Hermes.MCP.Error.internal_error/1","doc":"Creates an internal error.\n\nUsed when an internal server error occurs.","ref":"Hermes.MCP.Error.html#internal_error/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.internal_error/1","doc":"iex> Hermes.MCP.Error.internal_error()\n    %Hermes.MCP.Error{code: -32603, reason: :internal_error, data: %{}}","ref":"Hermes.MCP.Error.html#internal_error/1-examples"},{"type":"function","title":"Hermes.MCP.Error.invalid_params/1","doc":"Creates an invalid params error.\n\nUsed when the parameters provided are invalid for the requested method.","ref":"Hermes.MCP.Error.html#invalid_params/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.invalid_params/1","doc":"iex> Hermes.MCP.Error.invalid_params(%{param: \"name\"})\n    %Hermes.MCP.Error{code: -32602, reason: :invalid_params, data: %{param: \"name\"}}","ref":"Hermes.MCP.Error.html#invalid_params/1-examples"},{"type":"function","title":"Hermes.MCP.Error.invalid_request/1","doc":"Creates an invalid request error.\n\nUsed when the JSON sent is not a valid request object.","ref":"Hermes.MCP.Error.html#invalid_request/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.invalid_request/1","doc":"iex> Hermes.MCP.Error.invalid_request()\n    %Hermes.MCP.Error{code: -32600, reason: :invalid_request, data: %{}}","ref":"Hermes.MCP.Error.html#invalid_request/1-examples"},{"type":"function","title":"Hermes.MCP.Error.method_not_found/1","doc":"Creates a method not found error.\n\nUsed when the requested method does not exist or is not available.","ref":"Hermes.MCP.Error.html#method_not_found/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.method_not_found/1","doc":"iex> Hermes.MCP.Error.method_not_found(%{method: \"unknown_method\"})\n    %Hermes.MCP.Error{code: -32601, reason: :method_not_found, data: %{method: \"unknown_method\"}}","ref":"Hermes.MCP.Error.html#method_not_found/1-examples"},{"type":"function","title":"Hermes.MCP.Error.parse_error/1","doc":"Creates a parse error.\n\nUsed when the server is unable to parse the JSON received.","ref":"Hermes.MCP.Error.html#parse_error/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.parse_error/1","doc":"iex> Hermes.MCP.Error.parse_error()\n    %Hermes.MCP.Error{code: -32700, reason: :parse_error, data: %{}}","ref":"Hermes.MCP.Error.html#parse_error/1-examples"},{"type":"type","title":"Hermes.MCP.Error.t/0","doc":"","ref":"Hermes.MCP.Error.html#t:t/0"},{"type":"function","title":"Hermes.MCP.Error.to_tuple/1","doc":"Converts an MCP error to a tuple of the form `{:error, error}`.\n\nThis is useful for returning errors in functions that follow the \n`{:ok, result} | {:error, reason}` pattern.","ref":"Hermes.MCP.Error.html#to_tuple/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.to_tuple/1","doc":"iex> error = Hermes.MCP.Error.parse_error()\n    iex> Hermes.MCP.Error.to_tuple(error)\n    {:error, %Hermes.MCP.Error{code: -32700, reason: :parse_error, data: %{}}}","ref":"Hermes.MCP.Error.html#to_tuple/1-examples"},{"type":"function","title":"Hermes.MCP.Error.transport_error/2","doc":"Creates a transport-related error.\n\nUsed for communication/network errors between client and server.","ref":"Hermes.MCP.Error.html#transport_error/2"},{"type":"function","title":"Parameters - Hermes.MCP.Error.transport_error/2","doc":"* `reason` - Atom representing the specific transport error\n  * `data` - Additional error context or metadata","ref":"Hermes.MCP.Error.html#transport_error/2-parameters"},{"type":"function","title":"Examples - Hermes.MCP.Error.transport_error/2","doc":"iex> Hermes.MCP.Error.transport_error(:connection_refused)\n    %Hermes.MCP.Error{code: -32000, reason: :connection_refused, data: %{type: :transport}}","ref":"Hermes.MCP.Error.html#transport_error/2-examples"},{"type":"module","title":"Hermes.MCP.ID","doc":"Utilities for working with MCP message identifiers.\n\nThis module provides functions for generating request IDs and progress tokens\nused in the MCP protocol.","ref":"Hermes.MCP.ID.html"},{"type":"module","title":"ID Format - Hermes.MCP.ID","doc":"Generated IDs are Base64-encoded strings containing:\n- Timestamp component (to ensure temporal uniqueness)\n- Process identifier hash (to ensure process-level uniqueness)\n- Random component (to ensure collision resistance)\n\nThis format ensures uniqueness across nodes, processes, and repeated calls.","ref":"Hermes.MCP.ID.html#module-id-format"},{"type":"module","title":"Examples - Hermes.MCP.ID","doc":"```elixir\n# Generate a standard request ID\nrequest_id = Hermes.MCP.ID.generate()\n\n# Generate a progress token\nprogress_token = Hermes.MCP.ID.generate_progress_token()\n```","ref":"Hermes.MCP.ID.html#module-examples"},{"type":"function","title":"Hermes.MCP.ID.generate/0","doc":"Generates a unique request ID.\n\nCreates a Base64 encoded string containing:\n- Timestamp component (nanoseconds)\n- Process identifier hash\n- Random component","ref":"Hermes.MCP.ID.html#generate/0"},{"type":"function","title":"Examples - Hermes.MCP.ID.generate/0","doc":"iex> id = Hermes.MCP.ID.generate()\n    iex> is_binary(id)\n    true","ref":"Hermes.MCP.ID.html#generate/0-examples"},{"type":"function","title":"Hermes.MCP.ID.generate_progress_token/0","doc":"Generates a unique progress token.\n\nCreates a standard request ID with a \"progress_\" prefix for clarity.\nProgress tokens are used in the MCP protocol to track long-running operations.","ref":"Hermes.MCP.ID.html#generate_progress_token/0"},{"type":"function","title":"Examples - Hermes.MCP.ID.generate_progress_token/0","doc":"iex> token = Hermes.MCP.ID.generate_progress_token()\n    iex> String.starts_with?(token, \"progress_\")\n    true","ref":"Hermes.MCP.ID.html#generate_progress_token/0-examples"},{"type":"function","title":"Hermes.MCP.ID.generate_request_id/0","doc":"Generates a unique request ID.\n\nCreates a standard ID with a \"req_\" prefix for clarity.\nRequest IDs are used to correlate requests with their responses.","ref":"Hermes.MCP.ID.html#generate_request_id/0"},{"type":"function","title":"Examples - Hermes.MCP.ID.generate_request_id/0","doc":"iex> id = Hermes.MCP.ID.generate_request_id()\n    iex> String.starts_with?(id, \"req_\")\n    true","ref":"Hermes.MCP.ID.html#generate_request_id/0-examples"},{"type":"function","title":"Hermes.MCP.ID.timestamp_from_id/1","doc":"Extracts timestamp from an ID for debugging purposes.\n\nThis is primarily useful for troubleshooting timing issues or\nanalyzing the sequence of requests.","ref":"Hermes.MCP.ID.html#timestamp_from_id/1"},{"type":"function","title":"Parameters - Hermes.MCP.ID.timestamp_from_id/1","doc":"* `id` - An ID generated by this module","ref":"Hermes.MCP.ID.html#timestamp_from_id/1-parameters"},{"type":"function","title":"Returns - Hermes.MCP.ID.timestamp_from_id/1","doc":"* The timestamp (in nanoseconds) or nil if the ID cannot be parsed","ref":"Hermes.MCP.ID.html#timestamp_from_id/1-returns"},{"type":"function","title":"Examples - Hermes.MCP.ID.timestamp_from_id/1","doc":"iex> id = Hermes.MCP.ID.generate()\n    iex> timestamp = Hermes.MCP.ID.timestamp_from_id(id)\n    iex> is_integer(timestamp)\n    true\n    \n    iex> Hermes.MCP.ID.timestamp_from_id(\"invalid-id\")\n    nil","ref":"Hermes.MCP.ID.html#timestamp_from_id/1-examples"},{"type":"function","title":"Hermes.MCP.ID.valid?/1","doc":"Checks if a string appears to be a valid MCP ID.\n\nThis performs a basic validation to check if the string conforms\nto the expected ID format.","ref":"Hermes.MCP.ID.html#valid?/1"},{"type":"function","title":"Examples - Hermes.MCP.ID.valid?/1","doc":"iex> id = Hermes.MCP.ID.generate()\n    iex> Hermes.MCP.ID.valid?(id)\n    true\n    \n    iex> Hermes.MCP.ID.valid?(\"invalid-id\")\n    false","ref":"Hermes.MCP.ID.html#valid?/1-examples"},{"type":"function","title":"Hermes.MCP.ID.valid_progress_token?/1","doc":"Checks if a string appears to be a valid progress token.\n\nValidates that the string starts with \"progress_\" and the \nremainder is a valid MCP ID.","ref":"Hermes.MCP.ID.html#valid_progress_token?/1"},{"type":"function","title":"Examples - Hermes.MCP.ID.valid_progress_token?/1","doc":"iex> token = Hermes.MCP.ID.generate_progress_token()\n    iex> Hermes.MCP.ID.valid_progress_token?(token)\n    true\n    \n    iex> Hermes.MCP.ID.valid_progress_token?(\"not-a-token\")\n    false","ref":"Hermes.MCP.ID.html#valid_progress_token?/1-examples"},{"type":"function","title":"Hermes.MCP.ID.valid_request_id?/1","doc":"Checks if a string appears to be a valid request ID.\n\nValidates that the string starts with \"req_\" and the \nremainder is a valid MCP ID.","ref":"Hermes.MCP.ID.html#valid_request_id?/1"},{"type":"function","title":"Examples - Hermes.MCP.ID.valid_request_id?/1","doc":"iex> id = Hermes.MCP.ID.generate_request_id()\n    iex> Hermes.MCP.ID.valid_request_id?(id)\n    true\n    \n    iex> Hermes.MCP.ID.valid_request_id?(\"not-an-id\")\n    false","ref":"Hermes.MCP.ID.html#valid_request_id?/1-examples"},{"type":"module","title":"Hermes.MCP.Message","doc":"Handles parsing and validation of MCP (Model Context Protocol) messages using the Peri library.\n\nThis module provides functions to parse and validate MCP messages based on the Model Context Protocol schema","ref":"Hermes.MCP.Message.html"},{"type":"function","title":"Hermes.MCP.Message.decode/1","doc":"Decodes raw data (possibly containing multiple messages) into JSON-RPC messages.\n\nReturns either:\n- `{:ok, messages}` where messages is a list of parsed JSON-RPC messages\n- `{:error, reason}` if parsing fails","ref":"Hermes.MCP.Message.html#decode/1"},{"type":"function","title":"Hermes.MCP.Message.encode_error/2","doc":"Encodes an error message to a JSON-RPC 2.0 compliant string.\n\nReturns the encoded string with a newline character appended.","ref":"Hermes.MCP.Message.html#encode_error/2"},{"type":"function","title":"Hermes.MCP.Message.encode_log_message/3","doc":"Encodes a log message notification to be sent to the client.","ref":"Hermes.MCP.Message.html#encode_log_message/3"},{"type":"function","title":"Parameters - Hermes.MCP.Message.encode_log_message/3","doc":"* `level` - The log level (debug, info, notice, warning, error, critical, alert, emergency)\n  * `data` - The data to be logged (any JSON-serializable value)\n  * `logger` - Optional name of the logger issuing the message\n\nReturns the encoded notification string with a newline character appended.","ref":"Hermes.MCP.Message.html#encode_log_message/3-parameters"},{"type":"function","title":"Hermes.MCP.Message.encode_notification/1","doc":"Encodes a notification message to a JSON-RPC 2.0 compliant string.\n\nReturns the encoded string with a newline character appended.","ref":"Hermes.MCP.Message.html#encode_notification/1"},{"type":"function","title":"Hermes.MCP.Message.encode_progress_notification/3","doc":"Encodes a progress notification message to a JSON-RPC 2.0 compliant string.","ref":"Hermes.MCP.Message.html#encode_progress_notification/3"},{"type":"function","title":"Parameters - Hermes.MCP.Message.encode_progress_notification/3","doc":"* `progress_token` - The token that was provided in the original request (string or integer)\n  * `progress` - The current progress value (number)\n  * `total` - Optional total value for the operation (number)\n\nReturns the encoded string with a newline character appended.","ref":"Hermes.MCP.Message.html#encode_progress_notification/3-parameters"},{"type":"function","title":"Hermes.MCP.Message.encode_request/2","doc":"Encodes a request message to a JSON-RPC 2.0 compliant string.\n\nReturns the encoded string with a newline character appended.","ref":"Hermes.MCP.Message.html#encode_request/2"},{"type":"function","title":"Hermes.MCP.Message.encode_response/2","doc":"Encodes a response message to a JSON-RPC 2.0 compliant string.\n\nReturns the encoded string with a newline character appended.","ref":"Hermes.MCP.Message.html#encode_response/2"},{"type":"function","title":"Hermes.MCP.Message.error_schema/1","doc":"","ref":"Hermes.MCP.Message.html#error_schema/1"},{"type":"function","title":"Hermes.MCP.Message.error_schema!/1","doc":"","ref":"Hermes.MCP.Message.html#error_schema!/1"},{"type":"function","title":"Hermes.MCP.Message.get_schema/1","doc":"","ref":"Hermes.MCP.Message.html#get_schema/1"},{"type":"macro","title":"Hermes.MCP.Message.is_error/1","doc":"Determines if a JSON-RPC message is an error.","ref":"Hermes.MCP.Message.html#is_error/1"},{"type":"macro","title":"Hermes.MCP.Message.is_notification/1","doc":"Determines if a JSON-RPC message is a notification.","ref":"Hermes.MCP.Message.html#is_notification/1"},{"type":"macro","title":"Hermes.MCP.Message.is_request/1","doc":"Determines if a JSON-RPC message is a request.","ref":"Hermes.MCP.Message.html#is_request/1"},{"type":"macro","title":"Hermes.MCP.Message.is_response/1","doc":"Determines if a JSON-RPC message is a response.","ref":"Hermes.MCP.Message.html#is_response/1"},{"type":"function","title":"Hermes.MCP.Message.mcp_message_schema/1","doc":"","ref":"Hermes.MCP.Message.html#mcp_message_schema/1"},{"type":"function","title":"Hermes.MCP.Message.mcp_message_schema!/1","doc":"","ref":"Hermes.MCP.Message.html#mcp_message_schema!/1"},{"type":"function","title":"Hermes.MCP.Message.notification_schema/1","doc":"","ref":"Hermes.MCP.Message.html#notification_schema/1"},{"type":"function","title":"Hermes.MCP.Message.notification_schema!/1","doc":"","ref":"Hermes.MCP.Message.html#notification_schema!/1"},{"type":"function","title":"Hermes.MCP.Message.request_schema/1","doc":"","ref":"Hermes.MCP.Message.html#request_schema/1"},{"type":"function","title":"Hermes.MCP.Message.request_schema!/1","doc":"","ref":"Hermes.MCP.Message.html#request_schema!/1"},{"type":"function","title":"Hermes.MCP.Message.response_schema/1","doc":"","ref":"Hermes.MCP.Message.html#response_schema/1"},{"type":"function","title":"Hermes.MCP.Message.response_schema!/1","doc":"","ref":"Hermes.MCP.Message.html#response_schema!/1"},{"type":"function","title":"Hermes.MCP.Message.validate_message/1","doc":"Validates a decoded JSON message to ensure it complies with the MCP schema.","ref":"Hermes.MCP.Message.html#validate_message/1"},{"type":"module","title":"Hermes.MCP.Response","doc":"Represents successful responses in the MCP protocol.\n\nThis module provides a wrapper around JSON-RPC responses, handling\ndomain-specific error semantics for MCP's \"isError\" field in results.","ref":"Hermes.MCP.Response.html"},{"type":"module","title":"Response Structure - Hermes.MCP.Response","doc":"Each response includes:\n- `result`: The response data from the server\n- `id`: The request ID this response is associated with\n- `is_error`: Boolean flag indicating if this is a domain-level error","ref":"Hermes.MCP.Response.html#module-response-structure"},{"type":"module","title":"Domain vs. Protocol Errors - Hermes.MCP.Response","doc":"The MCP protocol distinguishes between two types of errors:\n\n1. Protocol errors: Standard JSON-RPC errors with error codes (handled by `Hermes.MCP.Error`)\n2. Domain errors: Valid responses that indicate application-level errors with `isError: true`\n\nThis module specifically handles domain errors, which are successful at the protocol level\nbut indicate failures at the application level.","ref":"Hermes.MCP.Response.html#module-domain-vs-protocol-errors"},{"type":"module","title":"Examples - Hermes.MCP.Response","doc":"```elixir\n# Create from a JSON-RPC response\nresponse = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"})\n\n# Check if the response is successful or has a domain error\nif Hermes.MCP.Response.success?(response) do\n  # Handle success\nelse\n  # Handle domain error\nend\n\n# Unwrap the response to get the result or error\ncase Hermes.MCP.Response.unwrap(response) do\n  {:ok, result} -> # Handle success\n  {:error, error} -> # Handle domain error\nend\n```","ref":"Hermes.MCP.Response.html#module-examples"},{"type":"function","title":"Hermes.MCP.Response.error?/1","doc":"Checks if the response has a domain error.","ref":"Hermes.MCP.Response.html#error?/1"},{"type":"function","title":"Examples - Hermes.MCP.Response.error?/1","doc":"iex> response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.error?(response)\n    false\n    \n    iex> error_response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"isError\" => true}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.error?(error_response)\n    true","ref":"Hermes.MCP.Response.html#error?/1-examples"},{"type":"function","title":"Hermes.MCP.Response.from_json_rpc/1","doc":"Creates a Response struct from a JSON-RPC response.\n\nAutomatically detects domain errors by checking for the \"isError\" field.","ref":"Hermes.MCP.Response.html#from_json_rpc/1"},{"type":"function","title":"Parameters - Hermes.MCP.Response.from_json_rpc/1","doc":"* `response` - A map containing the JSON-RPC response","ref":"Hermes.MCP.Response.html#from_json_rpc/1-parameters"},{"type":"function","title":"Examples - Hermes.MCP.Response.from_json_rpc/1","doc":"iex> Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{}, \"id\" => \"req_123\"})\n    %Hermes.MCP.Response{result: %{}, id: \"req_123\", is_error: false}\n    \n    iex> Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"isError\" => true}, \"id\" => \"req_123\"})\n    %Hermes.MCP.Response{result: %{\"isError\" => true}, id: \"req_123\", is_error: true}","ref":"Hermes.MCP.Response.html#from_json_rpc/1-examples"},{"type":"function","title":"Hermes.MCP.Response.get_id/1","doc":"Gets the request ID associated with this response.","ref":"Hermes.MCP.Response.html#get_id/1"},{"type":"function","title":"Examples - Hermes.MCP.Response.get_id/1","doc":"iex> response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.get_id(response)\n    \"req_123\"","ref":"Hermes.MCP.Response.html#get_id/1-examples"},{"type":"function","title":"Hermes.MCP.Response.get_result/1","doc":"Gets the result data from the response.\n\nThis function returns the raw result regardless of whether it represents\na success or domain error.","ref":"Hermes.MCP.Response.html#get_result/1"},{"type":"function","title":"Examples - Hermes.MCP.Response.get_result/1","doc":"iex> response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.get_result(response)\n    %{\"data\" => \"value\"}","ref":"Hermes.MCP.Response.html#get_result/1-examples"},{"type":"function","title":"Hermes.MCP.Response.success?/1","doc":"Checks if the response is successful (no domain error).","ref":"Hermes.MCP.Response.html#success?/1"},{"type":"function","title":"Examples - Hermes.MCP.Response.success?/1","doc":"iex> response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.success?(response)\n    true\n    \n    iex> error_response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"isError\" => true}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.success?(error_response)\n    false","ref":"Hermes.MCP.Response.html#success?/1-examples"},{"type":"type","title":"Hermes.MCP.Response.t/0","doc":"","ref":"Hermes.MCP.Response.html#t:t/0"},{"type":"function","title":"Hermes.MCP.Response.unwrap/1","doc":"Unwraps the response, returning the raw result.\n\nReturns the raw result data regardless of whether it represents\na success or domain error.","ref":"Hermes.MCP.Response.html#unwrap/1"},{"type":"function","title":"Examples - Hermes.MCP.Response.unwrap/1","doc":"iex> response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.unwrap(response)\n    %{\"data\" => \"value\"}\n    \n    iex> error_response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"isError\" => true, \"reason\" => \"not_found\"}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.unwrap(error_response)\n    %{\"isError\" => true, \"reason\" => \"not_found\"}","ref":"Hermes.MCP.Response.html#unwrap/1-examples"},{"type":"module","title":"Hermes.SSE","doc":"Server-Sent Events (SSE) utilities, HTTP client abstraction and HTTP streaming handling.","ref":"Hermes.SSE.html"},{"type":"function","title":"Hermes.SSE.connect/3","doc":"Connects to a server-sent event stream.","ref":"Hermes.SSE.html#connect/3"},{"type":"function","title":"Parameters - Hermes.SSE.connect/3","doc":"- `server_url` - the URL of the server to connect to.\n  - `headers` - additional headers to send with the request.\n  - `opts` - additional options to pass to the HTTP client.","ref":"Hermes.SSE.html#connect/3-parameters"},{"type":"function","title":"Examples - Hermes.SSE.connect/3","doc":"iex> Hermes.SSE.connect(\"http://localhost:4000\")\n    #Stream<[ref: 1, task: #PID<0.123.0>]>","ref":"Hermes.SSE.html#connect/3-examples"},{"type":"module","title":"Hermes.SSE.Event","doc":"Represents a Server-Sent Event.\n\nFields:\n  - `:id`    - identifier of the event (if any)\n  - `:event` - event type (defaults to \"message\")\n  - `:data`  - the event data (concatenates multiple data lines with a newline)\n  - `:retry` - reconnection time (parsed as integer, if provided)","ref":"Hermes.SSE.Event.html"},{"type":"type","title":"Hermes.SSE.Event.t/0","doc":"","ref":"Hermes.SSE.Event.html#t:t/0"},{"type":"module","title":"Hermes.SSE.Parser","doc":"Parses a raw SSE stream into a list of `%SSE.Event{}` structs.","ref":"Hermes.SSE.Parser.html"},{"type":"function","title":"Hermes.SSE.Parser.run/1","doc":"Parses a string containing one or more SSE events.\n\nEach event is separated by an empty line (two consecutive newlines).\nReturns a list of `%SSE.Event{}` structs.","ref":"Hermes.SSE.Parser.html#run/1"},{"type":"behaviour","title":"Hermes.Transport.Behaviour","doc":"Defines the behavior that all transport implementations must follow.","ref":"Hermes.Transport.Behaviour.html"},{"type":"type","title":"Hermes.Transport.Behaviour.message/0","doc":"The JSON-RPC message encoded","ref":"Hermes.Transport.Behaviour.html#t:message/0"},{"type":"type","title":"Hermes.Transport.Behaviour.reason/0","doc":"","ref":"Hermes.Transport.Behaviour.html#t:reason/0"},{"type":"callback","title":"Hermes.Transport.Behaviour.send_message/2","doc":"","ref":"Hermes.Transport.Behaviour.html#c:send_message/2"},{"type":"callback","title":"Hermes.Transport.Behaviour.shutdown/1","doc":"","ref":"Hermes.Transport.Behaviour.html#c:shutdown/1"},{"type":"callback","title":"Hermes.Transport.Behaviour.start_link/1","doc":"","ref":"Hermes.Transport.Behaviour.html#c:start_link/1"},{"type":"type","title":"Hermes.Transport.Behaviour.t/0","doc":"","ref":"Hermes.Transport.Behaviour.html#t:t/0"},{"type":"module","title":"Hermes.Transport.SSE","doc":"A transport implementation that uses Server-Sent Events (SSE) for receiving messages\nand HTTP POST requests for sending messages back to the server.\n\n>","ref":"Hermes.Transport.SSE.html"},{"type":"module","title":"Notes {: .info} - Hermes.Transport.SSE","doc":">\n> For initialization and setup, check our [Installation & Setup](./installation.html) and\n> the [Transport options](./transport_options.html) guides for reference.","ref":"Hermes.Transport.SSE.html#module-notes-info"},{"type":"function","title":"Hermes.Transport.SSE.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hermes.Transport.SSE.html#child_spec/1"},{"type":"function","title":"Hermes.Transport.SSE.get_schema/1","doc":"","ref":"Hermes.Transport.SSE.html#get_schema/1"},{"type":"type","title":"Hermes.Transport.SSE.option/0","doc":"The options for the SSE transport.\n\n- `:name` - The name of the transport process, respecting the `GenServer` \"Name Registration\" section.\n- `:client` - The client to send the messages to, respecting the `GenServer` \"Name Registration\" section.\n- `:server` - The server configuration.\n- `:headers` - The headers to send with the HTTP requests.\n- `:transport_opts` - The underlying HTTP transport options to pass to the HTTP client. You can check on the [Mint docs](https://hexdocs.pm/mint/Mint.HTTP.html#connect/4-transport-options)\n- `:http_options` - The underlying HTTP client options to pass to the HTTP client. You can check on the [Finch docs](https://hexdocs.pm/finch/Finch.html#t:request_opt/0)","ref":"Hermes.Transport.SSE.html#t:option/0"},{"type":"function","title":"Hermes.Transport.SSE.options_schema/1","doc":"","ref":"Hermes.Transport.SSE.html#options_schema/1"},{"type":"function","title":"Hermes.Transport.SSE.options_schema!/1","doc":"","ref":"Hermes.Transport.SSE.html#options_schema!/1"},{"type":"type","title":"Hermes.Transport.SSE.params_t/0","doc":"","ref":"Hermes.Transport.SSE.html#t:params_t/0"},{"type":"type","title":"Hermes.Transport.SSE.server/0","doc":"The options for the MCP server.\n\n- `:base_url` - The base URL of the MCP server (e.g. http://localhost:8000) (required).\n- `:base_path` - The base path of the MCP server (e.g. /mcp).\n- `:sse_path` - The path to the SSE endpoint (e.g. /mcp/sse) (default `:base_path` + `/sse`).","ref":"Hermes.Transport.SSE.html#t:server/0"},{"type":"type","title":"Hermes.Transport.SSE.t/0","doc":"","ref":"Hermes.Transport.SSE.html#t:t/0"},{"type":"module","title":"Hermes.Transport.STDIO","doc":"A transport implementation that uses standard input/output.\n\n>","ref":"Hermes.Transport.STDIO.html"},{"type":"module","title":"Notes {: .info} - Hermes.Transport.STDIO","doc":">\n> For initialization and setup, check our [Installation & Setup](./installation.html) and\n> the [Transport options](./transport_options.html) guides for reference.","ref":"Hermes.Transport.STDIO.html#module-notes-info"},{"type":"function","title":"Hermes.Transport.STDIO.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hermes.Transport.STDIO.html#child_spec/1"},{"type":"function","title":"Hermes.Transport.STDIO.get_schema/1","doc":"","ref":"Hermes.Transport.STDIO.html#get_schema/1"},{"type":"type","title":"Hermes.Transport.STDIO.option/0","doc":"The options for the STDIO transport.\n\n- `:command` - The command to run, it will be searched in the system's PATH.\n- `:args` - The arguments to pass to the command, as a list of strings.\n- `:env` - The extra environment variables to set for the command, as a map.\n- `:cwd` - The working directory for the command.\n- `:client` - The client to send the messages to, respecting the `GenServer` \"Name Registration\" section\n\nAnd any other `GenServer` init option.","ref":"Hermes.Transport.STDIO.html#t:option/0"},{"type":"function","title":"Hermes.Transport.STDIO.options_schema/1","doc":"","ref":"Hermes.Transport.STDIO.html#options_schema/1"},{"type":"function","title":"Hermes.Transport.STDIO.options_schema!/1","doc":"","ref":"Hermes.Transport.STDIO.html#options_schema!/1"},{"type":"type","title":"Hermes.Transport.STDIO.params_t/0","doc":"","ref":"Hermes.Transport.STDIO.html#t:params_t/0"},{"type":"type","title":"Hermes.Transport.STDIO.t/0","doc":"","ref":"Hermes.Transport.STDIO.html#t:t/0"},{"type":"module","title":"Mix.Interactive.CLI","doc":"Standalone CLI application for Hermes MCP interactive shells.\n\nThis module serves as the entry point for the standalone binary compiled with Burrito.\nIt can start either the SSE or STDIO interactive shell based on command-line arguments.","ref":"Mix.Interactive.CLI.html"},{"type":"function","title":"Mix.Interactive.CLI.check_client_connection/2","doc":"","ref":"Mix.Interactive.CLI.html#check_client_connection/2"},{"type":"function","title":"Mix.Interactive.CLI.check_sse_connection/2","doc":"","ref":"Mix.Interactive.CLI.html#check_sse_connection/2"},{"type":"function","title":"Mix.Interactive.CLI.main/1","doc":"Main entry point for the standalone CLI application.","ref":"Mix.Interactive.CLI.html#main/1"},{"type":"module","title":"Mix.Interactive.Commands","doc":"Common command implementations for interactive MCP shells.\n\nThis module contains the implementation of all commands available in the\ninteractive MCP shells. It provides a consistent set of commands across\ndifferent transport implementations, with shared functionality for:\n\n- Listing available commands\n- Fetching and displaying tools, prompts, and resources\n- Calling tools and getting prompts\n- Handling user input and error cases\n- Formatting and displaying results\n\nEach command follows a similar pattern, receiving client and loop function\nreferences to enable proper continuation of the interactive shell.","ref":"Mix.Interactive.Commands.html"},{"type":"function","title":"Mix.Interactive.Commands.commands/0","doc":"Returns the map of available commands and their descriptions.","ref":"Mix.Interactive.Commands.html#commands/0"},{"type":"function","title":"Mix.Interactive.Commands.process_command/3","doc":"Process a command entered by the user.","ref":"Mix.Interactive.Commands.html#process_command/3"},{"type":"module","title":"Mix.Interactive.Shell","doc":"Base functionality for interactive MCP shells.\n\nThis module acts as the core command loop for interactive MCP shells,\nproviding a consistent interface and user experience across different\ntransport implementations (SSE, STDIO).\n\nIt handles basic functionality like reading user input and delegating\ncommand processing to the appropriate handlers.","ref":"Mix.Interactive.Shell.html"},{"type":"function","title":"Mix.Interactive.Shell.loop/1","doc":"Main command loop for interactive shells.","ref":"Mix.Interactive.Shell.html#loop/1"},{"type":"module","title":"Mix.Interactive.State","doc":"State inspection utilities for the interactive MCP shell.\n\nThis module provides functions for inspecting, formatting, and displaying\nthe internal state of Hermes MCP client and transport processes, useful\nfor debugging and introspection purposes.","ref":"Mix.Interactive.State.html"},{"type":"module","title":"Features - Mix.Interactive.State","doc":"* Retrieves and formats client state information\n* Displays transport state (SSE or STDIO)\n* Pretty-prints nested data structures\n* Shows connection status and diagnostics\n* Highlights pending requests with timing information","ref":"Mix.Interactive.State.html#module-features"},{"type":"module","title":"Usage - Mix.Interactive.State","doc":"This module is primarily used by the interactive shell's `show_state` command\nto provide a human-readable view of the system's internal state.\n\n```elixir\n# From the commands module:\nMix.Interactive.State.print_state(client_pid)\n```","ref":"Mix.Interactive.State.html#module-usage"},{"type":"function","title":"Mix.Interactive.State.print_state/1","doc":"Prints the formatted state of the client and its associated transport.","ref":"Mix.Interactive.State.html#print_state/1"},{"type":"function","title":"Parameters - Mix.Interactive.State.print_state/1","doc":"* `client` - The client process to inspect","ref":"Mix.Interactive.State.html#print_state/1-parameters"},{"type":"module","title":"Mix.Interactive.UI","doc":"Common UI elements and formatting functions for interactive MCP shells.\n\nThis module provides consistent UI components and formatting helpers for\nthe interactive CLI interfaces used by the Hermes MCP mix tasks.\n\nIt includes functions for displaying colored text, formatted headers,\npretty-printing of data structures, and consistent output formatting.","ref":"Mix.Interactive.UI.html"},{"type":"function","title":"Mix.Interactive.UI.colors/0","doc":"Returns the color configuration map for styling output.","ref":"Mix.Interactive.UI.html#colors/0"},{"type":"function","title":"Mix.Interactive.UI.format_output/1","doc":"Formats JSON or other data for pretty-printing with indentation.","ref":"Mix.Interactive.UI.html#format_output/1"},{"type":"function","title":"Mix.Interactive.UI.header/1","doc":"Creates a styled header for an interactive session.","ref":"Mix.Interactive.UI.html#header/1"},{"type":"function","title":"Mix.Interactive.UI.print_error/1","doc":"Formats error messages with appropriate styling.","ref":"Mix.Interactive.UI.html#print_error/1"},{"type":"function","title":"Mix.Interactive.UI.print_items/3","doc":"Formats lists of tools/prompts/resources with helpful styling.","ref":"Mix.Interactive.UI.html#print_items/3"},{"type":"task","title":"mix hermes.sse.interactive","doc":"Mix task to test the SSE transport implementation, interactively sending commands.","ref":"Mix.Tasks.Hermes.Sse.Interactive.html"},{"type":"task","title":"Options - mix hermes.sse.interactive","doc":"* `--base-url` - Base URL for the SSE server (default: http://localhost:8000)\n* `--base-path` - Base path to append to the base URL\n* `--sse-path` - Specific SSE endpoint path","ref":"Mix.Tasks.Hermes.Sse.Interactive.html#module-options"},{"type":"function","title":"Mix.Tasks.Hermes.Sse.Interactive.run/1","doc":"","ref":"Mix.Tasks.Hermes.Sse.Interactive.html#run/1"},{"type":"task","title":"mix hermes.stdio.interactive","doc":"Mix task to test the STDIO transport implementation, interactively sending commands.","ref":"Mix.Tasks.Hermes.Stdio.Interactive.html"},{"type":"task","title":"Options - mix hermes.stdio.interactive","doc":"* `--command` - Command to execute for the STDIO transport (default: \"mcp\")\n* `--args` - Comma-separated arguments for the command (default: \"run,priv/dev/echo/index.py\")","ref":"Mix.Tasks.Hermes.Stdio.Interactive.html#module-options"},{"type":"function","title":"Mix.Tasks.Hermes.Stdio.Interactive.run/1","doc":"","ref":"Mix.Tasks.Hermes.Stdio.Interactive.html#run/1"},{"type":"extras","title":"Hermes MCP","doc":"# Hermes MCP\n\n[![hex.pm](https://img.shields.io/hexpm/v/hermes_mcp.svg)](https://hex.pm/packages/hermes_mcp)\n[![docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/hermes_mcp)\n[![ci](https://github.com/cloudwalk/hermes-mcp/actions/workflows/ci.yml/badge.svg)](https://github.com/cloudwalk/hermes-mcp/actions/workflows/ci.yml)\n\n> [!WARNING]\n>\n> This library is under active development, may expect breaking changes\n\nA high-performance Model Context Protocol (MCP) implementation in Elixir.","ref":"readme.html"},{"type":"extras","title":"Overview - Hermes MCP","doc":"Hermes MCP is a comprehensive Elixir SDK for the [Model Context Protocol](https://spec.modelcontextprotocol.io/), aiming to provide complete client and server implementations. The library leverages Elixir's exceptional concurrency model and fault tolerance capabilities to deliver a robust MCP experience.\n\nCurrently, Hermes MCP offers a feature-complete client implementation conforming to the MCP 2024-11-05 specification. Server-side components are planned for future releases.","ref":"readme.html#overview"},{"type":"extras","title":"Roadmap - Hermes MCP","doc":"","ref":"readme.html#roadmap"},{"type":"extras","title":"Current Status - Hermes MCP","doc":"- [x] Complete client implementation (MCP 2024-11-05)\n- [x] Multiple transport options (STDIO and HTTP/SSE)\n- [x] Built-in connection supervision and automatic recovery\n- [x] Comprehensive capability negotiation\n- [x] Progress tracking and cancellation support\n- [x] Structured logging system","ref":"readme.html#current-status"},{"type":"extras","title":"Upcoming - Hermes MCP","doc":"- [ ] Client support for MCP 2025-03-26 specification\n  - Authorization framework (OAuth 2.1)\n  - Streamable HTTP transport\n  - JSON-RPC batch operations\n  - Enhanced tool annotations\n\n- [ ] Server Implementation\n  - STDIO transport\n  - HTTP/SSE transport\n  - Streamable HTTP transport\n  - Support for resources, tools, and prompts\n\n- [ ] Sample Implementations\n  - Reference servers\n  - Integration examples with popular Elixir libraries\n\nFor a more detailed roadmap, see [ROADMAP.md](./ROADMAP.md).","ref":"readme.html#upcoming"},{"type":"extras","title":"Installation - Hermes MCP","doc":"","ref":"readme.html#installation"},{"type":"extras","title":"Library Usage - Hermes MCP","doc":"Add Hermes MCP to your dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:hermes_mcp, \"~> 0.3\"}\n  ]\nend\n```","ref":"readme.html#library-usage"},{"type":"extras","title":"Standalone CLI Installation - Hermes MCP","doc":"Download the appropriate binary for your platform from the [GitHub releases page](https://github.com/cloudwalk/hermes-mcp/releases).\n\n```bash\n# Make it executable (Linux/macOS)\n# or hermes_cli-macos-intel, hermes_cli-macos-arm\nmv hermes_mcp_linux hermes-mcp && chmod +x hermes-mcp\n\n# Run it\n./hermes-mcp --transport sse --base-url=\"http://localhost:8000\"\n```","ref":"readme.html#standalone-cli-installation"},{"type":"extras","title":"Quick Start - Hermes MCP","doc":"","ref":"readme.html#quick-start"},{"type":"extras","title":"Interactive Testing - Hermes MCP","doc":"Hermes MCP provides interactive tools for testing MCP servers with a user-friendly CLI.\n\n#### Using the CLI Binary:\n\n```bash\n# Test an SSE server\nhermes_cli --transport sse --base-url=\"http://localhost:8000\" --base-path=\"/mcp\"\n\n# Test a local process via STDIO\nhermes_cli --transport stdio --command=\"mcp\" --args=\"run,path/to/server.py\"\n```\n\n#### Using Mix Tasks (For Elixir Developers):\n\n```bash\n# Test an SSE server\nmix hermes.sse.interactive --base-url=\"http://localhost:8000\" --base-path=\"/mcp\"\n\n# Test a local process via STDIO\nmix hermes.stdio.interactive --command=\"mcp\" --args=\"run,path/to/server.py\"\n```\n\nThese interactive shells provide commands for listing and calling tools, exploring prompts, and accessing resources.","ref":"readme.html#interactive-testing"},{"type":"extras","title":"Setting up a Client - Hermes MCP","doc":"```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      # Start the MCP transport\n      {Hermes.Transport.STDIO, [\n        name: MyApp.MCPTransport,\n        client: MyApp.MCPClient, \n        command: \"mcp\",\n        args: [\"run\", \"path/to/server.py\"]\n      ]},\n      \n      # Start the MCP client using the transport\n      {Hermes.Client, [\n        name: MyApp.MCPClient,\n        transport: [layer: Hermes.Transport.STDIO, name: MyApp.MCPTransport],\n        client_info: %{\n          \"name\" => \"MyApp\",\n          \"version\" => \"1.0.0\"\n        },\n        capabilities: %{\n          \"roots\" => %{\"listChanged\" => true},\n          \"sampling\" => %{}\n        }\n      ]}\n    ]\n    \n    opts = [strategy: :one_for_all, name: MyApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"readme.html#setting-up-a-client"},{"type":"extras","title":"Making Client Requests - Hermes MCP","doc":"```elixir\n# Call a tool\n{:ok, result} = Hermes.Client.call_tool(MyApp.MCPClient, \"example_tool\", %{\"param\" => \"value\"})\n\n# Handle errors properly\ncase Hermes.Client.call_tool(MyApp.MCPClient, \"unavailable_tool\", %{}) do\n  {:ok, %Hermes.MCP.Response{}} ->\n    # Handle successful result\n    \n  {:error, %Hermes.MCP.Error{} = err} ->\n    # Handle error response\n    IO.puts(inspect(err, pretty: true))\nend\n```","ref":"readme.html#making-client-requests"},{"type":"extras","title":"Documentation - Hermes MCP","doc":"For detailed guides and examples, visit the [official documentation](https://hexdocs.pm/hermes_mcp)","ref":"readme.html#documentation"},{"type":"extras","title":"Why Hermes? - Hermes MCP","doc":"The library is named after Hermes, the Greek god of boundaries, communication, and commerce. This namesake reflects the core purpose of the Model Context Protocol: to establish standardized communication between AI applications and external tools.\n\nLike Hermes who served as a messenger between gods and mortals, this library facilitates seamless interaction between Large Language Models and various data sources or tools.","ref":"readme.html#why-hermes"},{"type":"extras","title":"Local Development - Hermes MCP","doc":"```bash\n# Setup the project\nmix setup\n\n# Run tests\nmix test\n\n# Code quality\nmix lint\n\n# Start development MCP servers\n# Echo server (Python)\njust echo-server\n# Calculator server (Go)\njust calculator-server\n```\n\nThe MCP servers in `priv/dev` require:\n- Python 3.11+ with uv (for echo server)\n- Go 1.21+ (for calculator server)\n\nSee [CONTRIBUTING.md](./CONTRIBUTING.md) for detailed contribution guidelines.","ref":"readme.html#local-development"},{"type":"extras","title":"License - Hermes MCP","doc":"Hermes MCP is released under the MIT License. See [LICENSE](./LICENSE) for details.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project are documented in this file.\n\n## [0.3.12](https://github.com/cloudwalk/hermes-mcp) - 2025-04-24","ref":"changelog.html"},{"type":"extras","title":"Fixed - Changelog","doc":"- Correctly handles \"nested\" timeouts (genserver vs MCP) (#71)\n\n## [0.3.11](https://github.com/cloudwalk/hermes-mcp) - 2025-04-17","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Improved core library logging and added verbosity level on interactive/CLI (#68)\n\n## [0.3.10](https://github.com/cloudwalk/hermes-mcp) - 2025-04-17","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Handle SSE ping and reconnect events from server (#65)\n\n## [0.3.9](https://github.com/cloudwalk/hermes-mcp) - 2025-04-15","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Improved and simplified SSE endpoint event URI merging (#64)","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Added internal client/transport state inspection on CLI/mix tasks (#61)\n\n## [0.3.8](https://github.com/cloudwalk/hermes-mcp) - 2025-04-10","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Created `Operation` struct to standardize client API calls (#56)\n- Fixed ERTS version to avoid release errors","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Resolved client timeout confusion by standardizing timeout handling (#42)\n\n## [0.3.7](https://github.com/cloudwalk/hermes-mcp) - 2025-04-01","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Client reinitialization from interactive CLI (#55)\n\n## [0.3.6](https://github.com/cloudwalk/hermes-mcp) - 2025-03-28","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- New roadmap and protocol update proposal (#53)\n- Added documentation for the 2025-03-26 protocol update\n\n## [0.3.5](https://github.com/cloudwalk/hermes-mcp) - 2025-03-25","ref":"changelog.html#added"},{"type":"extras","title":"Documentation - Changelog","doc":"- Added Roadmap to README (#47)\n\n## [0.3.4](https://github.com/cloudwalk/hermes-mcp) - 2025-03-20","ref":"changelog.html#documentation"},{"type":"extras","title":"Added - Changelog","doc":"- `help` command and flag on the interactive CLI (#37)\n- improve SSE connection status on interactive task/cli (#37)\n\n## [0.3.3](https://github.com/cloudwalk/hermes-mcp) - 2025-03-20","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Client request cancellation support (#35)\n- Improved URI path handling for SSE transport (#36)\n- Enhanced interactive mix tasks for testing MCP servers (#34)\n\n## [0.3.2](https://github.com/cloudwalk/hermes-mcp) - 2025-03-19","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Ship static binaries to use hermes-mcp as standlone application\n\n## [0.3.1](https://github.com/cloudwalk/hermes-mcp) - 2025-03-19","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Ship interactive mix tasks `stdio.interactive` and `sse.interactive` to test MCP servers\n\n## [0.3.0](https://github.com/cloudwalk/hermes-mcp) - 2025-03-18","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Structured server-client logging support (#27)\n- Progress notification tracking (#26)\n- MCP domain model implementation (#28)\n- Comprehensive SSE unit tests (#20)\n- Centralized state management (#31)\n- Standardized error response handling (#32)","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Improved domain error handling (#33)\n\n## [0.2.3](https://github.com/cloudwalk/hermes-mcp) - 2025-03-12","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Enhanced SSE transport with graceful shutdown capabilities (#25)\n- Improved SSE streaming with automatic reconnection handling (#25)\n\n## [0.2.2](https://github.com/cloudwalk/hermes-mcp) - 2025-03-05","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Support for multiple concurrent client <> transport pairs (#24)\n- Improved client resource management\n\n## [0.2.1](https://github.com/cloudwalk/hermes-mcp) - 2025-02-28","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Support for custom base and SSE paths in HTTP/SSE client (#19)\n- Enhanced configuration options for SSE endpoints\n\n## [0.2.0](https://github.com/cloudwalk/hermes-mcp) - 2025-02-27","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Implemented HTTP/SSE transport (#7)\n  - Support for server-sent events communication\n  - HTTP client integration for MCP protocol\n  - Streaming response handling","ref":"changelog.html#added"},{"type":"extras","title":"Documentation - Changelog","doc":"- Extensive guides and documentation improvements\n\n## [0.1.0](https://github.com/cloudwalk/hermes-mcp) - 2025-02-26","ref":"changelog.html#documentation"},{"type":"extras","title":"Added - Changelog","doc":"- Implemented STDIO transport (#1) for MCP communication\n  - Support for bidirectional communication via standard I/O\n  - Automatic process monitoring and recovery\n  - Environment variable handling for cross-platform support\n  - Integration test utilities in Mix tasks\n\n- Created stateful client interface (#6)\n  - Robust GenServer implementation for MCP client\n  - Automatic initialization and protocol handshake\n  - Synchronous-feeling API over asynchronous transport\n  - Support for all MCP operations (ping, resources, prompts, tools)\n  - Proper error handling and logging\n  - Capability negotiation and management\n\n- Developed JSON-RPC message parsing (#5)\n  - Schema-based validation of MCP messages\n  - Support for requests, responses, notifications, and errors\n  - Comprehensive test suite for message handling\n  - Encoding/decoding functions with proper validation\n\n- Established core architecture and client API\n  - MCP protocol implementation following specification\n  - Client struct for maintaining connection state\n  - Request/response correlation with unique IDs\n  - Initial transport abstraction layer","ref":"changelog.html#added"},{"type":"extras","title":"Documentation - Changelog","doc":"- Added detailed RFC document describing the library architecture\n- Enhanced README with project overview and installation instructions","ref":"changelog.html#documentation"},{"type":"extras","title":"Contributing to Hermes MCP","doc":"# Contributing to Hermes MCP\n\nThank you for your interest in contributing to Hermes MCP! This document provides guidelines and instructions for contributing to the project.\n\nFirstly, have sure to follow the official MCP (Model Context Protocol) [specification](https://spec.modelcontextprotocol.io/specification/2024-11-05/)!","ref":"contributing.html"},{"type":"extras","title":"Development Setup - Contributing to Hermes MCP","doc":"","ref":"contributing.html#development-setup"},{"type":"extras","title":"Prerequisites - Contributing to Hermes MCP","doc":"- Elixir 1.18+\n- Erlang/OTP 26+\n- Python 3.11+ with uv (for echo server)\n- Go 1.21+ (for calculator server)\n- Just command runner","ref":"contributing.html#prerequisites"},{"type":"extras","title":"Getting Started - Contributing to Hermes MCP","doc":"1. Clone the repository\n   ```bash\n   git clone https://github.com/cloudwalk/hermes-mcp.git\n   cd hermes-mcp\n   ```\n\n2. Install dependencies\n   ```bash\n   mix setup\n   ```\n\n3. Run tests to ensure everything is working\n   ```bash\n   mix test\n   ```","ref":"contributing.html#getting-started"},{"type":"extras","title":"Development Workflow - Contributing to Hermes MCP","doc":"","ref":"contributing.html#development-workflow"},{"type":"extras","title":"Running MCP Servers - Contributing to Hermes MCP","doc":"For development and testing, you can use the provided MCP server implementations:\n\n```bash\n# Start the Echo server (Python)\n# For now only support stdio transport\njust echo-server\n\n# Start the Calculator server (Go)\n# Supports both stdio and http/sse transpot\njust calculator-server sse\n```","ref":"contributing.html#running-mcp-servers"},{"type":"extras","title":"Code Quality - Contributing to Hermes MCP","doc":"Before submitting a pull request, ensure your code passes all quality checks:\n\n```bash\n# Run all code quality checks\nmix lint\n\n# Individual checks\nmix format        # Code formatting\nmix credo         # Linting\nmix dialyzer      # Type checking\n```","ref":"contributing.html#code-quality"},{"type":"extras","title":"Testing - Contributing to Hermes MCP","doc":"Write tests for all new features and bug fixes:\n\n```bash\n# Run all tests\nmix test\n```","ref":"contributing.html#testing"},{"type":"extras","title":"Submitting Contributions - Contributing to Hermes MCP","doc":"1. Create a new branch for your feature or bugfix\n   ```bash\n   git checkout -b feature/your-feature-name\n   ```\n\n2. Make your changes and commit them with clear, descriptive messages\n\n3. Push your branch to GitHub\n   ```bash\n   git push origin feature/your-feature-name\n   ```\n\n4. Open a pull request against the main branch","ref":"contributing.html#submitting-contributions"},{"type":"extras","title":"Pull Request Guidelines - Contributing to Hermes MCP","doc":"- Follow the existing code style and conventions\n- Include tests for new functionality\n- Update documentation as needed\n- Keep pull requests focused on a single topic\n- Reference any related issues in your PR description","ref":"contributing.html#pull-request-guidelines"},{"type":"extras","title":"Documentation - Contributing to Hermes MCP","doc":"Update documentation for any user-facing changes:\n\n- Update relevant sections in `pages/` directory\n- Add examples for new features\n- Document any breaking changes","ref":"contributing.html#documentation"},{"type":"extras","title":"Release Process - Contributing to Hermes MCP","doc":"Releases are managed by the maintainers. Version numbers follow [Semantic Versioning](https://semver.org/).","ref":"contributing.html#release-process"},{"type":"extras","title":"License - Contributing to Hermes MCP","doc":"By contributing to Hermes MCP, you agree that your contributions will be licensed under the project's [MIT License](./LICENSE).","ref":"contributing.html#license"},{"type":"extras","title":"LICENSE","doc":"Copyright 2025 zoedsoupe  \n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"Hermes MCP","doc":"# Hermes MCP\n\nA high-performance Model Context Protocol (MCP) implementation in Elixir with first-class Phoenix support.","ref":"home.html"},{"type":"extras","title":"Overview - Hermes MCP","doc":"Hermes MCP provides a unified solution for building both MCP clients and servers in Elixir, leveraging the language's exceptional concurrency model and fault tolerance capabilities. The library currently focuses on a robust client implementation, with server functionality planned for future releases.","ref":"home.html#overview"},{"type":"extras","title":"Key Features - Hermes MCP","doc":"- **High-Performance Client**: Built for concurrency and fault tolerance\n- **Multiple Transport Options**: Support for SSE and STDIO transports\n- **Interactive CLI Tools**: Command-line interfaces for testing and debugging ([CLI Usage Guide](cli_usage.html))\n- **Protocol-Compliant**: Full implementation of the Model Context Protocol specification","ref":"home.html#key-features"},{"type":"extras","title":"Protocol Compliance - Hermes MCP","doc":"Hermes MCP implements the [Model Context Protocol specification](https://spec.modelcontextprotocol.io/specification/2024-11-05/), ensuring interoperability with other MCP-compliant tools and services. The library handles all aspects of the MCP lifecycle, from initialization and capability negotiation to request routing and response handling.","ref":"home.html#protocol-compliance"},{"type":"extras","title":"Why Hermes? - Hermes MCP","doc":"The library is named after Hermes, the Greek god of boundaries, communication, and commerce. This namesake reflects the core purpose of the Model Context Protocol: to establish standardized communication between AI applications and external tools. Like Hermes who served as a messenger between gods and mortals, this library facilitates seamless interaction between Large Language Models and various data sources or tools.\n\nFurthermore, Hermes was known for his speed and reliability in delivering messages, which aligns with our implementation's focus on high performance and fault tolerance in the Elixir ecosystem.","ref":"home.html#why-hermes"},{"type":"extras","title":"Installation & Setup","doc":"# Installation & Setup\n\nSetting up Hermes MCP for your Elixir project involves a few straightforward steps.","ref":"installation.html"},{"type":"extras","title":"Adding the Dependency - Installation & Setup","doc":"Add Hermes MCP to your dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:hermes_mcp, \"~> 0.3\"}\n  ]\nend\n```\n\nThen run:\n\n```shell\nmix deps.get\n```","ref":"installation.html#adding-the-dependency"},{"type":"extras","title":"Supervision Tree Integration - Installation & Setup","doc":"Hermes MCP is designed to be integrated into your application's supervision tree. This provides robust lifecycle management and automatic recovery in case of failures.","ref":"installation.html#supervision-tree-integration"},{"type":"extras","title":"Basic Integration Example (stdio) - Installation & Setup","doc":"```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      # Start the MCP transport\n      {Hermes.Transport.STDIO, [\n        name: MyApp.MCPTransport,\n        client: MyApp.MCPClient,\n        command: \"mcp\",\n        args: [\"run\", \"path/to/server.py\"],\n        env: %{\"HOME\" => \"/Users/my-user\"}\n      ]},\n\n      # Start the MCP client using the transport\n      {Hermes.Client, [\n        name: MyApp.MCPClient,\n        transport: [\n          # layer is required\n          layer: Hermes.Transport.STDIO,\n          # you can give a custom name\n          name: MyApp.MCPTransport\n        ],\n        client_info: %{\n          \"name\" => \"MyApp\",\n          \"version\" => \"1.0.0\"\n        },\n        capabilities: %{\n          \"roots\" => %{\"listChanged\" => true},\n          \"sampling\" => %{}\n        }\n      ]}\n\n      # Your other application services\n      # ...\n    ]\n\n    opts = [strategy: :one_for_all, name: MyApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"installation.html#basic-integration-example-stdio"},{"type":"extras","title":"Configuration Options - Installation & Setup","doc":"","ref":"installation.html#configuration-options"},{"type":"extras","title":"Client Configuration - Installation & Setup","doc":"The `Hermes.Client` accepts the following options:\n\n| Option | Type | Description | Default |\n|--------|------|-------------|---------|\n| `:name` | atom | Registration name for the client process | `__MODULE__` |\n| `:transport` | enumerable | The transport options | Required |\n| `:transport.layer` | module | The transport layer, currently only `Hermes.Transport.STDIO` or `Hermes.Transport.SSE` | Required |\n| `:transport.name` | [GenServer.server](https://hexdocs.pm/elixir/GenServer.html#t:server/0) | An optional custom transport process name | The transport module |\n| `:client_info` | map | Information about the client | Required |\n| `:capabilities` | map | Client capabilities to advertise | `%{\"roots\" => %{\"listChanged\" => true}, \"sampling\" => %{}}` |\n| `:protocol_version` | string | Protocol version to use | `\"2024-11-05\"` |\n| `:request_timeout` | integer | Default timeout for requests in milliseconds | 30s |","ref":"installation.html#client-configuration"},{"type":"extras","title":"Transport Layer","doc":"# Transport Layer\n\nHermes MCP supports multiple transport mechanisms to connect clients with servers. This page covers the available options and how to configure them.","ref":"transport.html"},{"type":"extras","title":"Transport Behavior - Transport Layer","doc":"All transports in Hermes implement the `Hermes.Transport.Behaviour` behavior, which defines the interface for sending and receiving messages:\n\n```elixir\ndefmodule Hermes.Transport.Behaviour do\n  @moduledoc \"\"\"\n  Defines the behavior that all transport implementations must follow.\n  \"\"\"\n\n  @type t :: GenServer.server()\n  @typedoc \"The JSON-RPC message to send, encoded\"\n  @type message :: String.t()\n  @type reason :: term()\n\n  @callback start_link(keyword()) :: GenServer.on_start()\n  @callback send_message(t(), message()) :: :ok | {:error, reason()}\n  @callback shutdown(t()) :: :ok | {:error, reason()}\nend\n```\n\nThis standardized interface allows the client to work with different transport mechanisms interchangeably.","ref":"transport.html#transport-behavior"},{"type":"extras","title":"STDIO Transport - Transport Layer","doc":"The STDIO transport (`Hermes.Transport.STDIO`) enables communication with an MCP server running as a separate process. It's suitable for local integrations and communicates through standard input/output streams.","ref":"transport.html#stdio-transport"},{"type":"extras","title":"Configuration - Transport Layer","doc":"```elixir\n{Hermes.Transport.STDIO, [\n  name: MyApp.MCPTransport,\n  client: MyApp.MCPClient,\n  command: \"mcp\",\n  args: [\"run\", \"path/to/server.py\"],\n  env: %{\"CUSTOM_VAR\" => \"value\"},\n  cwd: \"/path/to/working/directory\"\n]}\n```","ref":"transport.html#configuration"},{"type":"extras","title":"Configuration Options - Transport Layer","doc":"| Option | Type | Description | Default |\n|--------|------|-------------|---------|\n| `:name` | [GenServer.name](https://hexdocs.pm/elixir/GenServer.html#t:name/0) | Registration name for the transport process | `__MODULE__` |\n| `:client` | [GenServer.server](https://hexdocs.pm/elixir/GenServer.html#t:server/0) | The client process that will receive messages | Required |\n| `:command` | string | The command to execute, it will be searched on `$PATH` | Required |\n| `:args` | list(String.t()) | Command line arguments | `[]` |\n| `:env` | map | Environment variables to merge into the default ones | System defaults |\n| `:cwd` | string | Working directory | Current directory (aka `Path.expand(\".\")`) |","ref":"transport.html#configuration-options"},{"type":"extras","title":"Example: Running a Python MCP Server - Transport Layer","doc":"```elixir\n{Hermes.Transport.STDIO, [\n  name: MyApp.MCPTransport,\n  client: MyApp.MCPClient,\n  command: \"python\",\n  args: [\"-m\", \"mcp.server\", \"my_server.py\"],\n  env: %{\"PYTHONPATH\" => \"/path/to/python/modules\"}\n]}\n```","ref":"transport.html#example-running-a-python-mcp-server"},{"type":"extras","title":"Example: Running a Node.js MCP Server - Transport Layer","doc":"```elixir\n{Hermes.Transport.STDIO, [\n  name: MyApp.MCPTransport,\n  client: MyApp.MCPClient,\n  command: \"node\",\n  args: [\"server.js\"],\n  env: %{\"NODE_ENV\" => \"production\"},\n  cwd: \"/path/to/server\"\n]}\n```","ref":"transport.html#example-running-a-node-js-mcp-server"},{"type":"extras","title":"HTTP/SSE Transport - Transport Layer","doc":"The HTTP/SSE transport (`Hermes.Transport.SSE`) enables communication with an MCP server over HTTP using [Server-Sent Events (SSE)](https://developer.mozilla.org/en-US/docs/Web/API/Server-sent_events/Using_server-sent_events). It's suitable for remote integrations and provides secure communication over TLS.","ref":"transport.html#http-sse-transport"},{"type":"extras","title":"Configuration - Transport Layer","doc":"```elixir\n{Hermes.Transport.SSE, [\n  name: MyApp.HTTPTransport,\n  client: MyApp.MCPClient,\n  server: [\n    base_url: \"https://example.com\",\n    base_path: \"/mcp\", # defaults to \"/\"\n    sse_path: \"/sse\" # defaults to `:base_path` <> \"/sse\"\n  ],\n  headers: [{\"Authorization\", \"Bearer token\"}],\n  transport_opts: [verify: :verify_peer],\n  http_options: [request_timeout: 30_000]\n]}\n```","ref":"transport.html#configuration"},{"type":"extras","title":"Configuration Options - Transport Layer","doc":"| Option | Type | Description | Default |\n|--------|------|-------------|---------|\n| `:name` | [GenServer.name](https://hexdocs.pm/elixir/GenServer.html#t:name/0) | Registration name for the transport process | `__MODULE__` |\n| `:client` | [GenServer.server](https://hexdocs.pm/elixir/GenServer.html#t:server/0) | The client process that will receive messages | Required |\n| `:server` | enumerable | The SSE server config | Required |\n| `:server.base_url` | string | The SSE server base url | Required |\n| `:server.base_path` | string | The SSE server base path | `\"/\"`|\n| `:server.sse_path` | string | The SSE server base path for starting a SSE connection | `\"/sse\"`|\n| `:headers` | map | Additional request headers to be sent | `%{}` |\n| `:transport_opts` | keyword | Options to be passed to the underlying HTTP Client, you can check the avaiable options on [Mint docs](https://hexdocs.pm/mint/Mint.HTTP.html#connect/4-transport-options) | System defaults |\n| `:http_options` | keyword | Options passed directly to the HTTP Client, you can check the available options on [Finch docs](https://hexdocs.pm/finch/Finch.html#t:request_opt/0) | Current directory |","ref":"transport.html#configuration-options"},{"type":"extras","title":"Custom Transport Implementation - Transport Layer","doc":"You can implement custom transports by creating a module that implements the `Hermes.Transport.Behaviour` behavior.","ref":"transport.html#custom-transport-implementation"},{"type":"extras","title":"Example: Custom TCP Transport - Transport Layer","doc":"```elixir\ndefmodule MyApp.Transport.TCP do\n  @behaviour Hermes.Transport.Behaviour\n\n  use GenServer\n\n  alias Hermes.Transport.Behaviour, as: Transport\n\n  @impl Transport\n  def start_link(opts) do\n    GenServer.start_link(__MODULE__, opts, name: opts[:name])\n  end\n\n  @impl Transport\n  def send_message(pid, message) when is_binary(message) do\n    GenServer.call(pid, {:send, message})\n  end\n\n  @impl Transport\n  def shutdown(pid) do\n    GenServer.cast(pid, :shutdown)\n  end\n\n  @impl GenServer\n  def init(opts) do\n    client = opts[:client]\n    host = opts[:host] || \"localhost\"\n    port = opts[:port] || 8080\n\n    case :gen_tcp.connect(String.to_charlist(host), port, [:binary, active: true]) do\n      {:ok, socket} ->\n        {:ok, %{socket: socket, client: client}}\n\n      {:error, reason} ->\n        {:stop, reason}\n    end\n  end\n\n  @impl GenServer\n  def handle_call({:send, message}, _from, %{socket: socket} = state) do\n    case :gen_tcp.send(socket, message) do\n      :ok -> {:reply, :ok, state}\n      {:error, reason} -> {:reply, {:error, reason}, state}\n    end\n  end\n\n  @impl GenServer\n  def handle_cast(:shutdown, %{socket: socket} = state) do\n    :gen_tcp.close(socket)\n    {:stop, :normal, state}\n  end\n\n  @impl GenServer\n  def handle_info({:tcp, _socket, data}, %{client: client} = state) do\n    # Forward data to client\n    GenServer.cast(client, {:response, data})\n    {:noreply, state}\n  end\n\n  def handle_info({:tcp_closed, _socket}, state) do\n    {:stop, :normal, state}\n  end\n\n  def handle_info({:tcp_error, _socket, reason}, state) do\n    {:stop, reason, state}\n  end\nend\n```","ref":"transport.html#example-custom-tcp-transport"},{"type":"extras","title":"Transport Lifecycle Management - Transport Layer","doc":"Transports in Hermes are designed to be supervised, with automatic recovery in case of failures:\n\n```elixir\n# In your supervision tree\nchildren = [\n  {Hermes.Transport.STDIO, transport_opts},\n  {Hermes.Client, client_opts},\n  # ...\n]\n\n# We recommend using :one_for_all strategy\n# to restart all children if one of them fails\n# since the client depends on the transport and vice-versa\nopts = [strategy: :one_for_all]\nSupervisor.start_link(children, opts)\n```","ref":"transport.html#transport-lifecycle-management"},{"type":"extras","title":"References - Transport Layer","doc":"You can find more detailed information about MCP transport layers on the official [MCP specification](https://spec.modelcontextprotocol.io/specification/2024-11-05/basic/transports/)","ref":"transport.html#references"},{"type":"extras","title":"Client Usage Guide","doc":"# Client Usage Guide\n\nThis guide covers the basic usage patterns for the Hermes MCP client.","ref":"client_usage.html"},{"type":"extras","title":"Client Lifecycle - Client Usage Guide","doc":"Once properly configured in your application's supervision tree, the Hermes client automatically handles:\n\n1. Initial connection to the server\n2. Protocol version negotiation\n3. Capability exchange\n4. Handshake completion\n\nFor example, if you're using the `Hermes.Transport.STDIO` layer for your client, this flow would lloks like to:\n\n```mermaid\nsequenceDiagram\n    participant Client\n    participant Server Process\n\n    Client->>+Server Process: Launch subprocess\n    loop Message Exchange\n        Client->>Server Process: Write to stdin\n        Server Process->>Client: Write to stdout\n        Server Process--)Client: Optional logs on stderr\n    end\n    Client->>Server Process: Close stdin, terminate subprocess\n    deactivate Server Process\n```\n\nOtherwise, if you're using the `Hermes.Transport.SSE` layer, the flow would look like this:\n\n```mermaid\nsequenceDiagram\n    participant Client\n    participant Server\n\n    Client->>Server: Open SSE connection\n    Server->>Client: endpoint event\n    loop Message Exchange\n        Client->>Server: HTTP POST messages\n        Server->>Client: SSE message events\n    end\n    Client->>Server: Close SSE connection\n```\n\n>","ref":"client_usage.html#client-lifecycle"},{"type":"extras","title":"Note {: .info} - Client Usage Guide","doc":">\n> These sequence diagrams can be found on the official [MCP specification](https://spec.modelcontextprotocol.io/specification/2024-11-05/basic/transports/)\n\nGenerally speaking, the client <> server lifecycle on MCP can be summarized as:\n\n1. **Initialization**: Capability negotiation and protocol version agreement\n2. **Operation**: Normal protocol communication\n3. **Shutdown**: Graceful termination of the connection\n\n```mermaid\nsequenceDiagram\n    participant Client\n    participant Server\n\n    Note over Client,Server: Initialization Phase\n    activate Client\n    Client->>+Server: initialize request\n    Server-->>Client: initialize response\n    Client--)Server: initialized notification\n\n    Note over Client,Server: Operation Phase\n    rect rgb(200, 220, 250)\n        note over Client,Server: Normal protocol operations\n    end\n\n    Note over Client,Server: Shutdown\n    Client--)-Server: Disconnect\n    deactivate Server\n    Note over Client,Server: Connection closed\n```","ref":"client_usage.html#note-info"},{"type":"extras","title":"Basic Operations - Client Usage Guide","doc":"","ref":"client_usage.html#basic-operations"},{"type":"extras","title":"Checking Connection Status - Client Usage Guide","doc":"You can check if a server is responsive with the `ping/1` function:\n\n```elixir\ncase Hermes.Client.ping(MyApp.MCPClient) do\n  :pong -> IO.puts(\"Server is responsive\")\n  {:error, reason} -> IO.puts(\"Connection error: #{inspect(reason)}\")\nend\n```","ref":"client_usage.html#checking-connection-status"},{"type":"extras","title":"Retrieving Server Information - Client Usage Guide","doc":"After initialization, you can access the server's capabilities and information:\n\n```elixir\n# Get server capabilities\nserver_capabilities = Hermes.Client.get_server_capabilities(MyApp.MCPClient)\nIO.inspect(server_capabilities, label: \"Server capabilities\")\n\n# Get server version information\nserver_info = Hermes.Client.get_server_info(MyApp.MCPClient)\nIO.inspect(server_info, label: \"Server info\")\n```","ref":"client_usage.html#retrieving-server-information"},{"type":"extras","title":"Working with Resources - Client Usage Guide","doc":"","ref":"client_usage.html#working-with-resources"},{"type":"extras","title":"Listing Resources - Client Usage Guide","doc":"To retrieve the list of available resources from the server:\n\n```elixir\ncase Hermes.Client.list_resources(MyApp.MCPClient) do\n  # this is an \"application\" error, from the server\n  {:ok, %Hermes.MCP.Response{is_error: true}} ->\n    IO.puts(\"Error listing resources\")\n\n  {:ok, %Hermes.MCP.Response{result: %{\"resources\" => resources}}} ->\n    IO.puts(\"Available resources:\")\n    Enum.each(resources, fn resource ->\n      IO.puts(\"  - #{resource[\"name\"]} (#{resource[\"uri\"]})\")\n    end)\n\n  # this is a transport/protocol error\n  {:error, %Hermes.MCP.Error{} = error} ->\n    IO.puts(\"Error listing resources: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#listing-resources"},{"type":"extras","title":"Pagination - Client Usage Guide","doc":"For large resource collections, you can use pagination with cursors:\n\n```elixir\n# First page\n{:ok, %Hermes.MCP.Response{result: %{\"resources\" => resources, \"nextCursor\" => cursor}}} =\n  Hermes.Client.list_resources(MyApp.MCPClient)\n\n# Get next page if a cursor is available\nif cursor do\n  {:ok, %Hermes.MCP.Response{result: %{\"resources\" => more_resources}}} =\n    Hermes.Client.list_resources(MyApp.MCPClient, cursor: cursor)\nend\n```","ref":"client_usage.html#pagination"},{"type":"extras","title":"Reading Resources - Client Usage Guide","doc":"To read the contents of a specific resource:\n\n```elixir\ncase Hermes.Client.read_resource(MyApp.MCPClient, \"file:///example.txt\") do\n  # this is an \"application\" error, from the server\n  {:ok, %Hermes.MCP.Response{is_error: true}} ->\n    IO.puts(\"Error reading resources\")\n\n  {:ok, %Hermes.MCP.Response{result: %{\"contents\" => contents}}} ->\n    Enum.each(contents, fn content ->\n      case content do\n        %{\"text\" => text} -> IO.puts(\"Text content: #{text}\")\n        %{\"blob\" => blob} -> IO.puts(\"Binary content: #{byte_size(blob)} bytes\")\n      end\n    end)\n\n  # this is a transport/protocol error\n  {:error, error} ->\n    IO.puts(\"Error reading resource: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#reading-resources"},{"type":"extras","title":"Working with Tools - Client Usage Guide","doc":"","ref":"client_usage.html#working-with-tools"},{"type":"extras","title":"Listing Tools - Client Usage Guide","doc":"To discover available tools:\n\n```elixir\ncase Hermes.Client.list_tools(MyApp.MCPClient) do\n  # this is an \"application\" error, from the server\n  {:ok, %Hermes.MCP.Response{is_error: true}} ->\n    IO.puts(\"Error listing tools\")\n\n  {:ok, %Hermes.MCP.Response{result: %{\"tools\" => tools}}} ->\n    IO.puts(\"Available tools:\")\n    Enum.each(tools, fn tool ->\n      IO.puts(\"  - #{tool[\"name\"]}: #{tool[\"description\"] || \"No description\"}\")\n    end)\n\n  # this is a transport/protocol error\n  {:error, error} ->\n    IO.puts(\"Error listing tools: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#listing-tools"},{"type":"extras","title":"Calling Tools - Client Usage Guide","doc":"To invoke a tool with arguments:\n\n```elixir\ntool_name = \"calculate\"\ntool_args = %{\"expression\" => \"2 + 2\"}\n\ncase Hermes.Client.call_tool(MyApp.MCPClient, tool_name, tool_args) do\n  # this is an \"application\" error, from the server\n  {:ok, %Hermes.MCP.Response{is_error: true}} ->\n    IO.puts(\"Tool execution error:\")\n    Enum.each(content, fn item ->\n      case item do\n        %{\"type\" => \"text\", \"text\" => text} -> IO.puts(\"  #{text}\")\n        _ -> IO.puts(\"  #{inspect(item)}\")\n      end\n    end)\n\n  {:ok, %Hermes.MCP.Response{result: %{\"content\" => content}}} ->\n    IO.puts(\"Tool result:\")\n    Enum.each(content, fn item ->\n      case item do\n        %{\"type\" => \"text\", \"text\" => text} -> IO.puts(\"  #{text}\")\n        _ -> IO.puts(\"  #{inspect(item)}\")\n      end\n    end)\n\n  # this is a transport/protocol error\n  {:error, error} ->\n    IO.puts(\"Error calling tool: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#calling-tools"},{"type":"extras","title":"Working with Prompts - Client Usage Guide","doc":"","ref":"client_usage.html#working-with-prompts"},{"type":"extras","title":"Listing Prompts - Client Usage Guide","doc":"To list available prompts:\n\n```elixir\ncase Hermes.Client.list_prompts(MyApp.MCPClient) do\n  # this is an \"application\" error, from the server\n  {:ok, %Hermes.MCP.Response{is_error: true}} ->\n    IO.puts(\"Error listing prompts\")\n\n  {:ok, %Hermes.MCP.Response{result: %{\"prompts\" => prompts}}} ->\n    IO.puts(\"Available prompts:\")\n    Enum.each(prompts, fn prompt ->\n      required_args = prompt[\"arguments\"]\n                      |> Enum.filter(& &1[\"required\"])\n                      |> Enum.map(& &1[\"name\"])\n                      |> Enum.join(\", \")\n\n      IO.puts(\"  - #{prompt[\"name\"]}\")\n      IO.puts(\"    Required args: #{required_args}\")\n    end)\n\n  # this is a transport/protocol error\n  {:error, error} ->\n    IO.puts(\"Error listing prompts: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#listing-prompts"},{"type":"extras","title":"Getting Prompts - Client Usage Guide","doc":"To retrieve a specific prompt with arguments:\n\n```elixir\nprompt_name = \"code_review\"\nprompt_args = %{\"code\" => \"def hello():\\n    print('world')\"}\n\ncase Hermes.Client.get_prompt(MyApp.MCPClient, prompt_name, prompt_args) do\n  # this is an \"application\" error, from the server\n  {:ok, %Hermes.MCP.Response{is_error: true}} ->\n    IO.puts(\"Error getting prompt\")\n\n  {:ok, %Hermes.MCP.Response{result: %{\"messages\" => messages}}} ->\n    IO.puts(\"Prompt messages:\")\n    Enum.each(messages, fn message ->\n      role = message[\"role\"]\n      content = case message[\"content\"] do\n        %{\"type\" => \"text\", \"text\" => text} -> text\n        _ -> inspect(message[\"content\"])\n      end\n\n      IO.puts(\"  #{role}: #{content}\")\n    end)\n\n  # this is a transport/protocol error\n  {:error, error} ->\n    IO.puts(\"Error getting prompt: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#getting-prompts"},{"type":"extras","title":"Operation Structure - Client Usage Guide","doc":"All client API calls use the `Hermes.Client.Operation` struct internally to standardize how requests are processed. This provides consistent handling of parameters, timeouts, and progress tracking.\n\n```elixir\n# Example of direct Operation usage (advanced)\noperation = Hermes.Client.Operation.new(%{\n  method: \"tools/call\",\n  params: %{\"name\" => \"calculator\", \"arguments\" => %{\"expression\" => \"2+2\"}},\n  timeout: to_timeout(second: 60),\n  progress_opts: [token: \"progress-123\", callback: fn token, progress, total -> IO.puts(\"Progress: #{progress}/#{total || \"unknown\"}\") end]\n})\n\n# Send operation directly (most users won't need this)\nGenServer.call(MyApp.MCPClient, {:operation, operation})\n```","ref":"client_usage.html#operation-structure"},{"type":"extras","title":"Timeouts and Cancellation - Client Usage Guide","doc":"You can specify custom timeouts for individual operations:\n\n```elixir\n# Use a custom timeout (in milliseconds)\nHermes.Client.call_tool(MyApp.MCPClient, \"slow_tool\", %{}, timeout: to_timeout(second: 60))\n```\n\nEach client API call accepts a `:timeout` option which overrides the default operation timeout (30 seconds). This timeout is operation-specific and does not affect other client requests.\n\n>","ref":"client_usage.html#timeouts-and-cancellation"},{"type":"extras","title":"Note {: .info} - Client Usage Guide","doc":">\n> Internally, the client uses two separate timeouts:\n> \n> 1. The **operation timeout** - Set via the `:timeout` option and used to trigger request timeouts\n> 2. The **GenServer.call timeout** - Derived from the operation timeout with a 1-second buffer\n>\n> The 1-second buffer ensures the operation timeout is triggered first, allowing the client to\n> properly send cancellation notifications to the server before any GenServer timeout occurs.\n> This prevents \"nested timeout\" issues where a GenServer timeout would occur without \n> the client knowing which request timed out.","ref":"client_usage.html#note-info"},{"type":"extras","title":"Extended Capabilities - Client Usage Guide","doc":"To extend the client's capabilities after initialization:\n\n```elixir\n# Add sampling capability\nnew_capabilities = %{\"sampling\" => %{}}\nupdated_capabilities = Hermes.Client.merge_capabilities(MyApp.MCPClient, new_capabilities)\n```","ref":"client_usage.html#extended-capabilities"},{"type":"extras","title":"Graceful Shutdown - Client Usage Guide","doc":"To gracefully close a client connection:\n\n```elixir\nHermes.Client.close(MyApp.MCPClient)\n```\n\n> This will shutdown the transport layer too","ref":"client_usage.html#graceful-shutdown"},{"type":"extras","title":"Message Handling","doc":"# Message Handling\n\nThis guide explains how Hermes MCP handles the flow of messages between clients and servers, including request/response patterns, notifications, and error handling.","ref":"message_handling.html"},{"type":"extras","title":"Message Types - Message Handling","doc":"Hermes implements all the standard JSON-RPC 2.0 message types as defined in the [MCP specification](https://spec.modelcontextprotocol.io/specification/2024-11-05/basic/messages/):\n\n1. **Requests**: Messages with a method, parameters, and ID that expect a response\n2. **Responses**: Successful results or errors matching a specific request ID\n3. **Notifications**: One-way messages with no response expected","ref":"message_handling.html#message-types"},{"type":"extras","title":"Message Flow Architecture - Message Handling","doc":"```\n┌────────────┐      ┌────────────┐      ┌────────────┐\n│            │      │            │      │            │\n│   Client   │<─────│  Transport │<─────│   Server   │\n│            │─────>│            │─────>│            │\n└────────────┘      └────────────┘      └────────────┘\n```\n\n1. The client sends requests and notifications to the transport layer\n2. The transport delivers these messages to the server\n3. The server processes messages and sends responses or notifications\n4. The transport delivers these back to the client\n5. The client correlates responses with their original requests","ref":"message_handling.html#message-flow-architecture"},{"type":"extras","title":"Request/Response Correlation - Message Handling","doc":"Hermes automatically handles correlation between requests and responses using unique message IDs that look like this:\n\n```\nreq_gdc_yngatmpd1namcqk\n```\n\nEach request is assigned a unique ID, and the client maintains a `MapSet` of pending requests:\n\n```elixir\n# Simplified example of internal state\n%{\n  pending_requests: %{\n    \"request_id_123\" => {from, \"method_name\"},\n    \"request_id_456\" => {from, \"other_method\"}\n  }\n}\n```\n\nWhen a response arrives, it's matched to the original request and forwarded to the waiting caller process.","ref":"message_handling.html#request-response-correlation"},{"type":"extras","title":"Timeouts and Recovery - Message Handling","doc":"Hermes implements automatic timeout handling for requests:\n\nIf a response isn't received within the timeout period, the client will:\n\n1. Remove the request from the pending requests map\n2. Send a cancellation notification to the server\n3. Return an error to the caller","ref":"message_handling.html#timeouts-and-recovery"},{"type":"extras","title":"Notification Handling - Message Handling","doc":"Notifications are one-way messages that don't expect a response. Generally, client and server should exchange notifications internally, without involving an explicit call from the caller process.\n\nHowever, there's one exception: request cancellation. When a client cancels a request with either `Hermes.Client.cancel_request/3` or `Hermes.Client.cancel_all_requests/2`, it sends a `notifications/cancelled` notification to the server to stop processing the request.","ref":"message_handling.html#notification-handling"},{"type":"extras","title":"Protocol Message Encoding/Decoding - Message Handling","doc":"Hermes uses a structured approach to encode and validate protocol messages.\n\nThe `Hermes.MCP.Message` module provides robust validation of all messages against the [MCP JSON schema](https://github.com/modelcontextprotocol/specification/blob/main/schema/2024-11-05/schema.json)","ref":"message_handling.html#protocol-message-encoding-decoding"},{"type":"extras","title":"Progress Tracking","doc":"# Progress Tracking\n\nHermes MCP supports progress notifications for long-running operations as specified in the [MCP protocol](https://spec.modelcontextprotocol.io/specification/2024-11-05/basic/utilities/progress/).","ref":"progress_tracking.html"},{"type":"extras","title":"Overview - Progress Tracking","doc":"The MCP specification includes a progress notification mechanism that allows communicating the progress of long-running operations. Progress updates are useful for:\n\n- Providing feedback for long-running server operations\n- Updating users about the status of operations that might take time to complete\n- Enabling client applications to display progress indicators for better UX","ref":"progress_tracking.html#overview"},{"type":"extras","title":"Progress Tokens - Progress Tracking","doc":"Progress is tracked using tokens that uniquely identify a specific operation. Hermes provides a helper function to generate unique tokens:\n\n```elixir\n# Generate a unique progress token\nprogress_token = Hermes.MCP.ID.generate_progress_token()\n```","ref":"progress_tracking.html#progress-tokens"},{"type":"extras","title":"Making Requests with Progress Tracking - Progress Tracking","doc":"Any client API request can include progress tracking options. Internally, these options are encapsulated in the `Operation` struct, which standardizes how client operations are handled:\n\n```elixir\n# Make a request with progress tracking\nHermes.Client.read_resource(client, \"resource-uri\",\n  progress: [token: progress_token]\n)\n```","ref":"progress_tracking.html#making-requests-with-progress-tracking"},{"type":"extras","title":"Internal Operation Structure - Progress Tracking","doc":"Behind the scenes, client methods create an `Operation` struct that encapsulates the method, parameters, progress options, and timeout:\n\n```elixir\n# This is what happens internally in client methods\noperation = Operation.new(%{\n  method: \"resources/read\",\n  params: %{\"uri\" => uri},\n  progress_opts: [token: progress_token, callback: callback],\n  timeout: custom_timeout\n})\n```\n\nThe `Operation` struct provides a standardized way to handle all client requests with consistent timeout and progress tracking behavior.","ref":"progress_tracking.html#internal-operation-structure"},{"type":"extras","title":"Receiving Progress Updates - Progress Tracking","doc":"You can combine the token and callback in a single request:\n\n```elixir\ntoken = Hermes.MCP.ID.generate_progress_token()\n\ncallback = fn ^token, progress, total ->\n  IO.puts(\"Progress: #{progress}/#{total || \"unknown\"}\")\nend\n\nHermes.Client.list_tools(client, progress: [token: token, callback: callback])\n```","ref":"progress_tracking.html#receiving-progress-updates"},{"type":"extras","title":"Logging","doc":"# Logging\n\nHermes MCP supports server-to-client logging as specified in the [MCP protocol](https://spec.modelcontextprotocol.io/specification/2024-11-05/server/utilities/logging/). This allows servers to send structured log messages to clients for debugging and operational visibility.","ref":"logging.html"},{"type":"extras","title":"Overview - Logging","doc":"The logging mechanism follows the standard syslog severity levels and provides a way for servers to emit structured log messages. Clients can control the verbosity by setting minimum log levels, and register callbacks to handle log messages for custom processing.","ref":"logging.html#overview"},{"type":"extras","title":"Setting Log Level - Logging","doc":"Clients can specify the minimum log level they want to receive from servers:\n\n```elixir\n# Configure the client to receive logs at \"info\" level or higher\n{:ok, _} = Hermes.Client.set_log_level(client, \"info\")\n```\n\nAvailable log levels, in order of increasing severity:\n- `\"debug\"` - Detailed information for debugging\n- `\"info\"` - General information messages\n- `\"notice\"` - Normal but significant events\n- `\"warning\"` - Warning conditions\n- `\"error\"` - Error conditions\n- `\"critical\"` - Critical conditions\n- `\"alert\"` - Action must be taken immediately\n- `\"emergency\"` - System is unusable\n\nSetting a level will result in receiving all messages at that level and above (more severe).","ref":"logging.html#setting-log-level"},{"type":"extras","title":"Receiving Log Messages - Logging","doc":"","ref":"logging.html#receiving-log-messages"},{"type":"extras","title":"Registering Callbacks - Logging","doc":"You can register a callback function to process log messages as they are received:\n\n```elixir\n# Register a callback to handle incoming log messages\nHermes.Client.register_log_callback(client, fn level, data, logger ->\n  IO.puts(\"[#{level}] #{if logger, do: \"[#{logger}] \", else: \"\"}#{inspect(data)}\")\nend)\n```\n\nThe callback function receives:\n- `level` - The log level (debug, info, notice, etc.)\n- `data` - The log data (any JSON-serializable value)\n- `logger` - Optional string identifying the logger source","ref":"logging.html#registering-callbacks"},{"type":"extras","title":"Unregistering Callbacks - Logging","doc":"When you no longer need to process log messages, unregister the callback:\n\n```elixir\n# Unregister a previously registered callback\nHermes.Client.unregister_log_callback(client)\n# :ok\n```","ref":"logging.html#unregistering-callbacks"},{"type":"extras","title":"Integrating with Elixir's Logger - Logging","doc":"By default, Hermes MCP automatically logs received messages to `Logger` app, mapping MCP log levels to their Elixir equivalents:\n\n- `\"debug\"` → `Logger.debug/1`\n- `\"info\"`, `\"notice\"` → `Logger.info/1`\n- `\"warning\"` → `Logger.warning/1`\n- `\"error\"`, `\"critical\"`, `\"alert\"`, `\"emergency\"` → `Logger.error/1`\n\nThis provides seamless integration with your existing logging setup, respecting the logger level you\ndefine con your config.","ref":"logging.html#integrating-with-elixir-s-logger"},{"type":"extras","title":"Error Handling","doc":"# Error Handling\n\nThis guide explains how errors are handled in the Hermes MCP library.","ref":"error_handling.html"},{"type":"extras","title":"Error Types - Error Handling","doc":"Hermes MCP distinguishes between three types of errors:\n\n1. **Protocol errors** (JSON-RPC errors): Standard errors defined by the JSON-RPC 2.0 specification\n2. **Domain errors**: Application-level errors reported by the server with `isError: true`\n3. **Client-side errors**: Errors generated by the client before reaching the server","ref":"error_handling.html#error-types"},{"type":"extras","title":"Error Representation - Error Handling","doc":"Protocol and client-side errors in Hermes MCP are represented as `{:error, %Hermes.MCP.Error{}}` tuples, where `Error` is a struct with:\n\n- `code`: The numeric error code, as an integer\n- `reason`: The atom reason (e.g., `:parse_error`, `:method_not_found`)\n- `data`: Additional error context, as a map\n\nDomain errors (with `isError: true`) are returned as `{:ok, %Hermes.MCP.Response{}}` tuples, where the response includes:\n\n- `result`: The original result from the server (including the `isError` field), as a map\n- `id`: The request ID, generated from `Hermes.MCP.ID.generate_request_id/0`\n- `is_error`: A boolean flag indicating if this is a domain error or \"success\"","ref":"error_handling.html#error-representation"},{"type":"extras","title":"Protocol Errors - Error Handling","doc":"Protocol errors (JSON-RPC errors) use the standard JSON-RPC error codes with specific reason atoms:\n\n```elixir\n{:error, %Hermes.MCP.Error{\n  code: -32601,\n  reason: :method_not_found,\n  data: %{original_message: \"Method not found\"}\n}}\n```\n\nStandard JSON-RPC error codes:\n- `-32700`: Parse error (`:parse_error`)\n- `-32600`: Invalid request (`:invalid_request`)\n- `-32601`: Method not found (`:method_not_found`)\n- `-32602`: Invalid params (`:invalid_params`)\n- `-32603`: Internal error (`:internal_error`)\n- `-32000`: Server error (`:server_error`)","ref":"error_handling.html#protocol-errors"},{"type":"extras","title":"Domain Errors - Error Handling","doc":"Domain errors (application-level errors) are valid JSON-RPC responses with `isError: true` and are represented as:\n\n```elixir\n{:ok, %Hermes.MCP.Response{\n  result: %{\n    \"isError\" => true,\n    \"reason\" => \"tool_not_found\",\n    \"message\" => \"Tool 'unknown' not found\",\n    \"details\" => %{\"toolName\" => \"unknown\"}\n  },\n  id: \"req_123\",\n  is_error: true\n}}\n```","ref":"error_handling.html#domain-errors"},{"type":"extras","title":"Client-Side Errors - Error Handling","doc":"Client-specific errors follow the same error struct pattern with appropriate reason atoms:\n\n```elixir\n# Transport error\n{:error, %Hermes.MCP.Error{\n  code: -32000,\n  reason: :connection_refused,\n  data: %{type: :transport}\n}}\n\n# Capability error\n{:error, %Hermes.MCP.Error{\n  code: -32601,\n  reason: :method_not_found,\n  data: %{method: \"resources/list\"}\n}}\n\n# Timeout error\n{:error, %Hermes.MCP.Error{\n  code: -32000,\n  reason: :request_timeout,\n  data: %{type: :client, message: \"Request timed out after 30000ms\"}\n}}\n\n> **Note:** Each client API call accepts a `:timeout` option which can be used to set a custom timeout for individual operations. The default timeout for all operations is 30 seconds.\n```","ref":"error_handling.html#client-side-errors"},{"type":"extras","title":"Handling Errors - Error Handling","doc":"You can pattern match on the response structure to handle different error types:\n\n```elixir\ncase Hermes.Client.call_tool(\"search\", %{query: \"example\"}) do\n  {:ok, %Hermes.MCP.Response{is_error: false, result: result}} ->\n    # Handle success\n    handle_success(result)\n\n  {:ok, %Hermes.MCP.Response{is_error: true, result: result}} ->\n    # Handle domain/application error\n    case result do\n      %{\"reason\" => \"not_found\"} ->\n        Logger.warning(\"Resource not found: #{result[\"message\"]}\")\n\n      %{\"reason\" => \"permission_denied\"} ->\n        Logger.error(\"Permission denied: #{result[\"message\"]}\")\n\n      _ ->\n        Logger.error(\"Other domain error: #{inspect(result)}\")\n    end\n\n  {:error, %Hermes.MCP.Error{reason: :method_not_found}} ->\n    # Handle unsupported method\n    Logger.warning(\"Method not supported by this server\")\n\n  {:error, %Hermes.MCP.Error{reason: reason}} when reason in [:connection_refused, :timeout] ->\n    # Handle transport errors\n    Logger.error(\"Transport error: #{reason}\")\n\n  {:error, %Hermes.MCP.Error{} = error} ->\n    # Handle any other error\n    Logger.error(\"Unexpected error: #{inspect(error)}\")\nend\n```","ref":"error_handling.html#handling-errors"},{"type":"extras","title":"Error Inspection - Error Handling","doc":"For better debugging, errors implement a custom Inspect protocol:\n\n```\n#MCP.Error \n```","ref":"error_handling.html#error-inspection"},{"type":"extras","title":"Interactive CLI Usage","doc":"# Interactive CLI Usage\n\nHermes MCP provides interactive command-line interfaces that allow you to directly interact with MCP servers. These CLI tools are useful for:\n\n- Testing and debugging MCP servers\n- Exploring available tools and resources\n- Rapid prototyping and development\n- Diagnostic purposes","ref":"cli_usage.html"},{"type":"extras","title":"Available CLI Tools - Interactive CLI Usage","doc":"Hermes provides two built-in interactive CLIs:\n\n1. **SSE Interactive**: For connecting to HTTP/SSE MCP servers\n2. **STDIO Interactive**: For connecting to STDIO-based MCP servers","ref":"cli_usage.html#available-cli-tools"},{"type":"extras","title":"Starting the CLI - Interactive CLI Usage","doc":"","ref":"cli_usage.html#starting-the-cli"},{"type":"extras","title":"SSE Interactive - Interactive CLI Usage","doc":"The SSE interactive CLI connects to HTTP-based MCP servers using Server-Sent Events (SSE).\n\n```shell\nmix hermes.sse.interactive --base-url=https://your-mcp-server.com\n```","ref":"cli_usage.html#sse-interactive"},{"type":"extras","title":"STDIO Interactive - Interactive CLI Usage","doc":"The STDIO interactive CLI connects to subprocess-based MCP servers using standard input/output.\n\n```shell\nmix hermes.stdio.interactive --command=path/to/server --args=arg1,arg2\n```","ref":"cli_usage.html#stdio-interactive"},{"type":"extras","title":"Command-Line Options - Interactive CLI Usage","doc":"Both CLIs support the following common options:\n\n| Option | Description |\n|--------|-------------|\n| `-h, --help` | Show help message and exit |\n| `-v` | Set log level (accumulating flag) |\n|      | No flag: `:error` level (default) |\n|      | `-v`: `:warning` level |\n|      | `-vv`: `:info` level |\n|      | `-vvv`: `:debug` level |","ref":"cli_usage.html#command-line-options"},{"type":"extras","title":"SSE Transport Options - Interactive CLI Usage","doc":"| Option | Description | Default |\n|--------|-------------|---------|\n| `--base-url URL` | Base URL for SSE server | http://localhost:8000 |\n| `--base-path PATH` | Base path for the SSE server | / |\n| `--sse-path PATH` | Path for SSE endpoint | /sse |","ref":"cli_usage.html#sse-transport-options"},{"type":"extras","title":"STDIO Transport Options - Interactive CLI Usage","doc":"| Option | Description | Default |\n|--------|-------------|---------|\n| `-c, --command CMD` | Command to execute | mcp |\n| `--args ARGS` | Comma-separated arguments for the command | run,priv/dev/echo/index.py |","ref":"cli_usage.html#stdio-transport-options"},{"type":"extras","title":"Interactive Commands - Interactive CLI Usage","doc":"Once connected, the CLI provides an interactive shell with several commands:\n\n| Command | Description |\n|---------|-------------|\n| `help` | Show list of available commands |\n| `ping` | Send a ping to the server to check connection health |\n| `list_tools` | List available server tools |\n| `call_tool` | Call a server tool with arguments |\n| `list_prompts` | List available server prompts |\n| `get_prompt` | Get a server prompt |\n| `list_resources` | List available server resources |\n| `read_resource` | Read a server resource |\n| `show_state` | Show internal state of client and transport |\n| `initialize` | Retry server connection initialization |\n| `clear` | Clear the screen |\n| `exit` | Exit the interactive session |","ref":"cli_usage.html#interactive-commands"},{"type":"extras","title":"Using the `show_state` Command - Interactive CLI Usage","doc":"The `show_state` command provides detailed information about the internal state of both the client and transport processes. This is particularly useful for debugging connection issues.\n\n```\nmcp> show_state\n```\n\nThis will display:\n- Client state information (protocol version, client info, server capabilities, etc.)\n- Transport state (connection details, status)\n- Pending requests (if any)\n\nFor more detailed error information, use the `--verbose` flag when starting the CLI or set the `HERMES_VERBOSE=1` environment variable.","ref":"cli_usage.html#using-the-show_state-command"},{"type":"extras","title":"Examples - Interactive CLI Usage","doc":"","ref":"cli_usage.html#examples"},{"type":"extras","title":"Connecting to a Local SSE Server - Interactive CLI Usage","doc":"```shell\nmix hermes.sse.interactive\n```","ref":"cli_usage.html#connecting-to-a-local-sse-server"},{"type":"extras","title":"Connecting to a Remote SSE Server - Interactive CLI Usage","doc":"```shell\nmix hermes.sse.interactive --base-url=https://remote-server.example.com --verbose\n```","ref":"cli_usage.html#connecting-to-a-remote-sse-server"},{"type":"extras","title":"Running a Local MCP Server with STDIO - Interactive CLI Usage","doc":"```shell\nmix hermes.stdio.interactive --command=./my-mcp-server --args=arg1,arg2\n```","ref":"cli_usage.html#running-a-local-mcp-server-with-stdio"},{"type":"extras","title":"Checking Server Connection - Interactive CLI Usage","doc":"```\nmcp> ping\n# Shows if the server is responding with a pong\n```","ref":"cli_usage.html#checking-server-connection"},{"type":"extras","title":"Calling a Tool - Interactive CLI Usage","doc":"```\nmcp> list_tools\n# Lists available tools\n\nmcp> call_tool\nTool name: calculator\nTool arguments (JSON): {\"operation\": \"+\", \"a\": 1, \"b\": 2}\n# Returns: 3\n```","ref":"cli_usage.html#calling-a-tool"},{"type":"extras","title":"Advanced Debugging - Interactive CLI Usage","doc":"```shell\n# Basic error-only logging (default)\nmix hermes.sse.interactive\n\n# Warning-level logging\nmix hermes.sse.interactive -v\n\n# Info-level logging\nmix hermes.sse.interactive -vv\n\n# Debug-level (most verbose) logging\nmix hermes.sse.interactive -vvv\n```\n\nThe verbosity level controls which log messages are displayed:\n- Default (no flags): Only errors are shown\n- `-v`: Errors and warnings are shown\n- `-vv`: Errors, warnings, and info messages are shown\n- `-vvv`: All messages including debug details are shown\n\nUse the `show_state` command to see detailed internal state information, or examine extended error information when initialization fails.","ref":"cli_usage.html#advanced-debugging"},{"type":"extras","title":"RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"# RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","ref":"rfc.html"},{"type":"extras","title":"1. Introduction - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"This document defines the design and architecture of an Elixir library that implements both the client and server aspects of the Model Context Protocol (MCP). The goal is to provide a unified solution that supports robust JSON‑RPC 2.0 communication, leverages Elixir's concurrency and fault tolerance, and integrates seamlessly with Phoenix for server operations. The library will expose a high‑level client API that abstracts transport details and a server API that is compliant with Phoenix conventions for building HTTP endpoints. The design is modular, extensible, and structured to support future enhancements.\n\nFor further context on MCP, see the [Anthropic announcement](https://www.anthropic.com/news/model-context-protocol) and the [Glama Quickstart](https://glama.ai/blog/2024-11-25-model-context-protocol-quickstart).\n\n---","ref":"rfc.html#1-introduction"},{"type":"extras","title":"2. Library Architecture Overview - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"","ref":"rfc.html#2-library-architecture-overview"},{"type":"extras","title":"2.1 General Structure - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The library is divided into two main components: the Client and the Server. Both components share core infrastructure for JSON‑RPC handling, configuration, and error management. The Client is designed to provide a high‑level API that abstracts connection management and messaging details, while the Server exposes MCP functionality through Phoenix‑compliant endpoints.\n\nA central configuration module governs the behavior of both components, allowing runtime customization of timeouts, protocol versions, and transport preferences. Middleware hooks are provided at strategic points to support additional processing such as authentication, logging, or transformation.","ref":"rfc.html#2-1-general-structure"},{"type":"extras","title":"2.2 Core Components - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"At the lowest level, a transport abstraction layer decouples the specifics of STDIO, HTTP, or other transports from the core logic. The connection manager (implemented as a GenServer) oversees the client's lifecycle, including the initialization handshake and message correlation. For the server, a dispatcher module routes incoming JSON‑RPC messages (received via a Phoenix controller or Plug) to the appropriate tool handler registered in a tool registry. These components are organized under a comprehensive supervision tree to ensure fault tolerance and automatic recovery.\n\n---","ref":"rfc.html#2-2-core-components"},{"type":"extras","title":"3. Protocol Lifecycle Management - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The Model Context Protocol defines specific lifecycle requirements that both clients and servers must implement. Our Elixir library provides unified lifecycle management that serves both roles through shared infrastructure while maintaining clear separation of concerns.","ref":"rfc.html#3-protocol-lifecycle-management"},{"type":"extras","title":"3.1 Shared Infrastructure - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The library implements the protocol lifecycle through a state machine that governs connection establishment, message exchange, and termination. This shared infrastructure leverages Elixir's GenServer and supervision capabilities to provide robust state management and fault tolerance regardless of whether the library is operating in client or server mode.\n\n```mermaid\nstateDiagram-v2\n    [*] --> Initializing\n    Initializing --> Active: Capability Exchange Complete\n    Active --> Recovering: Connection Issue\n    Recovering --> Initializing: Retry Connection\n    Active --> Terminating: Shutdown Requested\n    Recovering --> Terminating: Recovery Failed\n    Terminating --> [*]\n```","ref":"rfc.html#3-1-shared-infrastructure"},{"type":"extras","title":"3.2 Client Lifecycle - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"When operating as a client, the library actively initiates and manages connections to MCP servers. The client connection manager handles the following responsibilities:\n\nThe client begins by establishing a transport connection and sending an initialization request containing its capabilities and protocol version. Upon receiving the server's capability response, it validates compatibility and transitions to the active state. Throughout the session, it maintains correlation between requests and responses while monitoring connection health.\n\nDuring recovery scenarios, the client connection manager attempts to reestablish the transport connection and reinitialize the protocol session. It provides configurable retry policies and transparent recovery when possible.","ref":"rfc.html#3-2-client-lifecycle"},{"type":"extras","title":"3.3 Server Lifecycle - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"As a server, the library acts as a passive participant in lifecycle management, responding to client initiatives while maintaining session isolation. The server session manager creates dedicated processes for each client connection, ensuring proper resource cleanup on termination.\n\nWhen receiving a client's initialization request, the server validates the protocol version compatibility and responds with its supported capabilities. It then maintains session state for the connection, tracking active subscriptions and managing resource access. The server uses Phoenix's connection management facilities when operating over HTTP/SSE transport.","ref":"rfc.html#3-3-server-lifecycle"},{"type":"extras","title":"3.4 Lifecycle Integration - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The following sequence diagram illustrates how the client and server components interact during a typical protocol lifecycle:\n\n```mermaid\nsequenceDiagram\n    participant Client\n    participant Transport\n    participant Server\n    \n    Note over Client,Server: Transport Establishment\n    Client->>Transport: Connect\n    Transport->>Server: Accept Connection\n    \n    Note over Client,Server: Initialization Phase\n    Client->>Server: Initialize Request (capabilities)\n    Server-->>Client: Initialize Response (capabilities)\n    Client->>Server: Initialized Notification\n    \n    Note over Client,Server: Active Session\n    Client->>Server: Protocol Messages\n    Server-->>Client: Protocol Responses\n    \n    Note over Client,Server: Termination\n    Client->>Server: Close Connection\n    Server-->>Client: Acknowledge Close\n```","ref":"rfc.html#3-4-lifecycle-integration"},{"type":"extras","title":"3.5 Error Management - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The library implements comprehensive error handling for both client and server roles. Errors are categorized into:\n\nProtocol Errors: Version mismatches or capability incompatibilities are handled through standardized error responses that maintain protocol compliance.\n\nTransport Errors: Connection failures trigger appropriate recovery mechanisms based on the component's role. Clients attempt reconnection while servers clean up affected sessions.\n\nApplication Errors: Errors during tool execution or resource access are propagated through the protocol's error reporting mechanisms while maintaining session stability.\n\nThis unified approach to lifecycle management ensures protocol compliance while providing robust operation in both client and server roles. The library's supervision strategies and process isolation enable reliable recovery from failure scenarios while maintaining proper resource cleanup.","ref":"rfc.html#3-5-error-management"},{"type":"extras","title":"4. Engineering Considerations - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"","ref":"rfc.html#4-engineering-considerations"},{"type":"extras","title":"4.1 Client Implementation - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The client's core responsibility is to manage the connection and message exchange with an MCP server. A GenServer will serve as the connection manager, maintaining state (such as pending message IDs and associated callbacks) and handling the initialization handshake. The transport layer will be defined by a set of behaviors, which will allow developers to implement additional transport modules (e.g., STDIO or WebSocket) without modifying the core client logic. Error handling is performed through standardized mappings to Elixir's error tuples, and configurable timeouts are implemented to avoid blocking calls.","ref":"rfc.html#4-1-client-implementation"},{"type":"extras","title":"4.2 Server Implementation - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"For the server, Phoenix integration is a primary design goal. The library will provide a Plug/Phoenix module that acts as the HTTP interface for MCP. Incoming JSON‑RPC messages are first parsed and validated, then dispatched to the correct tool handler as registered in the tool registry. The dispatcher module uses asynchronous Tasks to invoke tool handlers, ensuring that long‑running operations do not delay the overall request-response cycle. Session management is achieved by isolating client interactions within dedicated processes, which allows the server to maintain state and context for each connection independently. Additionally, extensive logging and observability hooks are built in to facilitate debugging and performance monitoring.","ref":"rfc.html#4-2-server-implementation"},{"type":"extras","title":"4.3 Shared and Extensible Architecture - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"Both the client and server components share a common configuration module that reads settings from Elixir's configuration files (e.g., config.exs). Middleware hooks are available for both sides, enabling developers to insert custom authentication, logging, or transformation logic into the processing pipeline. The design adheres to a strict supervision tree structure to automatically recover from process failures and to maintain high availability. This shared architecture not only simplifies maintenance but also ensures that future enhancements can be integrated with minimal disruption.","ref":"rfc.html#4-3-shared-and-extensible-architecture"},{"type":"extras","title":"5. Roadmap for Version 0.1.0 - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The roadmap for version 0.1.0 focuses on delivering a robust and well-tested client interface before expanding to full server functionality.","ref":"rfc.html#5-roadmap-for-version-0-1-0"},{"type":"extras","title":"5.1 Phase 1: Design and Requirements (Weeks 1-2) - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"During this phase, a detailed design document is created based on the MCP specification. This includes defining the minimal set of features for the client, specifying the public API functions (connect/1, request/2, notify/2), and designing the transport abstraction layer. Prototypes for the connection manager are built and validated against simulated MCP server responses.","ref":"rfc.html#5-1-phase-1-design-and-requirements-weeks-1-2"},{"type":"extras","title":"5.2 Phase 2: Core Client Module Implementation (Weeks 3-5) - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"In this phase, the core client module is developed. The connection manager GenServer is implemented, handling the JSON‑RPC handshake and managing state for pending requests. Basic error handling and timeout logic are integrated, and unit tests are written for each component. The transport abstraction is implemented initially for STDIO, with a clear interface for future extensions.","ref":"rfc.html#5-2-phase-2-core-client-module-implementation-weeks-3-5"},{"type":"extras","title":"5.3 Phase 3: Transport Abstraction and High-Level API (Weeks 6-7) - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The focus shifts to refining the transport abstraction layer, ensuring that it supports multiple transport mechanisms seamlessly. The high‑level client API is finalized to provide idiomatic functions that hide low‑level details. Documentation is updated with usage examples and configuration guidelines.","ref":"rfc.html#5-3-phase-3-transport-abstraction-and-high-level-api-weeks-6-7"},{"type":"extras","title":"5.4 Phase 4: Integration Testing and Documentation (Weeks 8-9) - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"Comprehensive integration tests are performed by simulating connections to a basic test MCP server. Detailed documentation, including API reference guides and example applications, is produced. Performance metrics, logging outputs, and error scenarios are verified to ensure that the client component meets production standards.","ref":"rfc.html#5-4-phase-4-integration-testing-and-documentation-weeks-8-9"},{"type":"extras","title":"5.5 Phase 5: Beta Release and Feedback (Week 10) - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"A beta version of version 0.1.0 is released to early adopters. Feedback is collected regarding usability, stability, and performance. Based on this feedback, necessary adjustments are made before finalizing the release. This phase sets the stage for subsequent versions that will incorporate full server functionality with Phoenix integration and additional transport support.","ref":"rfc.html#5-5-phase-5-beta-release-and-feedback-week-10"},{"type":"extras","title":"6. Conclusion - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"This RFC has outlined the complete technical design for an Elixir MCP library that provides both client and server capabilities. The public API is designed to be high‑level for the client—abstracting connection and message handling—and fully compliant with Phoenix for the server side. The document details the architecture, internal flows, and the phased roadmap for version 0.1.0, focusing initially on establishing a robust client interface. The modular, extensible design ensures that the library can evolve to support additional features such as dynamic tool registration, middleware enhancements, and alternative transport mechanisms.","ref":"rfc.html#6-conclusion"},{"type":"extras","title":"References - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"1.\tIntroducing the Model Context Protocol – Anthropic\n2.\tMCP Quickstart – Glama\n3.\tModel Context Protocol – Linkup","ref":"rfc.html#references"},{"type":"extras","title":"MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"# MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26\n\nThis guide documents the major changes between MCP specification versions 2024-11-05 and 2025-03-26, \nand outlines a roadmap for upgrading Hermes MCP to support the new version while maintaining \nbackward compatibility.","ref":"protocol_upgrade_2025_03_26.html"},{"type":"extras","title":"Protocol Version Comparison - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"","ref":"protocol_upgrade_2025_03_26.html#protocol-version-comparison"},{"type":"extras","title":"Major Changes - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"| Feature | 2024-11-05 | 2025-03-26 | Impact |\n|---------|------------|------------|--------|\n| Authorization | Not present | Comprehensive OAuth 2.1 based framework | Major addition |\n| HTTP Transport | HTTP+SSE (separate endpoints) | Streamable HTTP (single endpoint) | Breaking change |\n| Batching | Not supported | JSON-RPC batching supported | New capability |\n| Tool Annotations | Basic metadata | Comprehensive annotations (read-only, destructive, etc.) | Enhancement |\n| Audio Content | Not supported | Supported alongside text and image | New capability |\n| Progress Updates | Basic progress info | Added descriptive message field | Enhancement |\n| Completions | Implicit | Explicit capability | Enhancement |","ref":"protocol_upgrade_2025_03_26.html#major-changes"},{"type":"extras","title":"Breaking Changes Details - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"#### 1. Authorization Framework\n\nThe 2025-03-26 specification introduces a comprehensive OAuth 2.1 based authorization framework including:\n\n- Server Metadata Discovery (RFC8414)\n- Dynamic Client Registration Protocol (RFC7591)\n- Session management via headers\n- Support for different OAuth grant types\n\nThis primarily impacts HTTP-based transports and doesn't apply to STDIO connections.\n\n#### 2. Streamable HTTP Transport\n\nThe new transport replaces separate SSE and HTTP endpoints with a single \"MCP endpoint\" that supports:\n\n- Both GET and POST methods\n- Response content negotiation\n- Session management via `Mcp-Session-Id` header\n- Stream resumability with the `Last-Event-ID` header\n\nThis is a significant change to the transport layer architecture and requires careful implementation to maintain backward compatibility.\n\n#### 3. JSON-RPC Batching\n\nThe 2025-03-26 specification adds support for JSON-RPC batching, allowing multiple requests to be sent and received in a single operation. This affects:\n\n- Message encoding/decoding\n- Request tracking\n- Error handling","ref":"protocol_upgrade_2025_03_26.html#breaking-changes-details"},{"type":"extras","title":"Upgrading Roadmap - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"","ref":"protocol_upgrade_2025_03_26.html#upgrading-roadmap"},{"type":"extras","title":"Phase 1: Preparation and Compatibility Layer - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"1. **Implement Protocol Version Detection and Negotiation**\n   - Enhance `Hermes.Client` to handle multiple protocol versions\n   - Implement version-specific capabilities handling\n\n2. **Transport Layer Compatibility**\n   - Maintain `Hermes.Transport.SSE` for 2024-11-05\n   - Create new transport for 2025-03-26 Streamable HTTP protocol\n   - Ensure graceful backwards compatibility\n\n3. **Message Handling Updates**\n   - Update message handling to support both protocol versions\n   - Add structures to handle version-specific features","ref":"protocol_upgrade_2025_03_26.html#phase-1-preparation-and-compatibility-layer"},{"type":"extras","title":"Phase 2: Core Feature Implementation - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"1. **Implement Streamable HTTP Transport**\n   - Develop new transport implementation based on the spec\n   - Support both content types (application/json and text/event-stream)\n   - Implement session management\n   - Add stream resumability\n\n2. **Add Authorization Support**\n   - Implement OAuth 2.1 support for HTTP transport\n   - Add Server Metadata Discovery\n   - Support Dynamic Client Registration\n   - Handle token management and refresh\n\n3. **Add JSON-RPC Batching**\n   - Enhance Message module to handle batched messages\n   - Update client API to support batched operations\n   - Implement state tracking for batched requests\n\n4. **Implement Tool Annotations**\n   - Update tool handling to support detailed annotations\n   - Add helper functions for checking tool properties","ref":"protocol_upgrade_2025_03_26.html#phase-2-core-feature-implementation"},{"type":"extras","title":"Phase 3: API Enhancements and Documentation - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"1. **Enhance Client API**\n   - Add explicit completions support\n   - Update progress notifications to include message field\n   - Support audio content type\n\n2. **Refine Backward Compatibility**\n   - Ensure seamless operation with both protocol versions\n   - Implement auto-detection where possible\n   - Add migration helpers\n\n3. **Update Documentation**\n   - Document new features and API changes\n   - Provide migration guides for users","ref":"protocol_upgrade_2025_03_26.html#phase-3-api-enhancements-and-documentation"},{"type":"extras","title":"API Impact Analysis - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"","ref":"protocol_upgrade_2025_03_26.html#api-impact-analysis"},{"type":"extras","title":"Minimal-Impact Changes - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"These changes should have little or no impact on the existing API:\n\n- Tool annotations\n- Audio content\n- Message field for progress\n- Completions capability","ref":"protocol_upgrade_2025_03_26.html#minimal-impact-changes"},{"type":"extras","title":"Potential Breaking Changes - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"#### Authorization\n\nThe authorization flow will require new parameters and client setup:\n\n```elixir\n# Current client initialization\nHermes.Client.start_link(\n  name: :mcp_client,\n  transport: [layer: Hermes.Transport.SSE],\n  client_info: %{\"name\" => \"MyClient\", \"version\" => \"1.0.0\"}\n)\n\n# With authorization (conceptual)\nHermes.Client.start_link(\n  name: :mcp_client,\n  transport: [\n    layer: Hermes.Transport.HTTP,\n    auth: [\n      client_id: \"client_id\",\n      redirect_uri: \"http://localhost:8000/callback\",\n      auth_callback: &MyApp.handle_auth_flow/1\n    ]\n  ],\n  client_info: %{\"name\" => \"MyClient\", \"version\" => \"1.0.0\"}\n)\n```\n\n#### Transport Layer\n\nUsers explicitly using `Hermes.Transport.SSE` will need to update to the new transport or use a compatibility mechanism.","ref":"protocol_upgrade_2025_03_26.html#potential-breaking-changes"},{"type":"extras","title":"Backward Compatibility Considerations - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"1. **Protocol Version Negotiation**\n   - Allow clients to specify preferred protocol versions\n   - Automatically negotiate based on server capabilities\n   - Fallback gracefully to supported versions\n\n2. **Transport Abstraction**\n   - Keep transport implementation details internal where possible\n   - Use polymorphic behavior through protocols or behaviors\n\n3. **Gradual Deprecation Path**\n   - Mark 2024-11-05 specific features as deprecated\n   - Provide clear migration path in documentation\n   - Eventually remove deprecated features in a future major version","ref":"protocol_upgrade_2025_03_26.html#backward-compatibility-considerations"},{"type":"extras","title":"Conclusion - MCP Protocol Upgrade Guide: 2024-11-05 to 2025-03-26","doc":"The upgrade to MCP 2025-03-26 introduces significant changes, particularly around transport and authorization. \nBy using a phased approach with careful abstractions, we can implement these changes while maintaining \nbackward compatibility.\n\nThe most challenging aspects will be:\n\n1. Supporting both transport models simultaneously\n2. Implementing the OAuth flow in a user-friendly way\n3. Managing the increased complexity of version-specific code paths\n\nThis document will be updated as implementation progresses with more specific details and examples.","ref":"protocol_upgrade_2025_03_26.html#conclusion"},{"type":"extras","title":"Hermes MCP Roadmap","doc":"# Hermes MCP Roadmap\n\nThis document outlines the development roadmap for Hermes MCP, an Elixir implementation of the Model Context Protocol (MCP). The roadmap is organized by key milestones and development areas.","ref":"roadmap.html"},{"type":"extras","title":"Current Status - Hermes MCP Roadmap","doc":"Hermes MCP currently provides a complete client implementation for the MCP 2024-11-05 specification with:\n\n- Full protocol lifecycle management (initialization, operation, shutdown)\n- Multiple transport options (STDIO and HTTP/SSE)\n- Connection supervision and automatic recovery\n- Comprehensive capability negotiation\n- Progress tracking for long-running operations\n- Cancellation support\n- Structured logging\n- Interactive test shell for development","ref":"roadmap.html#current-status"},{"type":"extras","title":"Upcoming Milestones - Hermes MCP Roadmap","doc":"","ref":"roadmap.html#upcoming-milestones"},{"type":"extras","title":"1. MCP 2025-03-26 Specification Support - Hermes MCP Roadmap","doc":"The MCP specification was updated on 2025-03-26 with several breaking changes and new features. Our implementation plan includes:\n\n#### Phase 1: Core Infrastructure (Q2 2025)\n\n- Support for protocol version negotiation\n- Multi-version compatibility layer\n- Backward compatibility with 2024-11-05 servers\n\n#### Phase 2: Transport Layer Updates (Q2-Q3 2025)\n\n- Implement Streamable HTTP transport\n- Maintain compatibility with HTTP+SSE for older servers\n- Support session management via `Mcp-Session-Id` header\n- Implement stream resumability with `Last-Event-ID`\n\n#### Phase 3: New Protocol Features (Q3 2025)\n\n- Support for OAuth 2.1 authorization framework\n  - Server metadata discovery\n  - Dynamic client registration\n  - Token management and refresh\n- JSON-RPC batching for improved performance\n- Enhanced tool annotations\n- Explicit completions capability\n- Audio content type support\n- Message field for progress notifications\n\nSee [protocol_upgrade_2025_03_26.md](./pages/protocol_upgrade_2025_03_26.md) for detailed information about these changes.","ref":"roadmap.html#1-mcp-2025-03-26-specification-support"},{"type":"extras","title":"2. Server Implementation (Q3-Q4 2025) - Hermes MCP Roadmap","doc":"After stabilizing the client implementation for both protocol versions, we plan to develop a complete server-side implementation:\n\n#### Phase 1: Core Server Infrastructure\n\n- Server-side protocol implementation\n- Capability management\n- Request handling framework\n- Resource, prompt, and tool abstractions\n\n#### Phase 2: Transport Implementations\n\n- STDIO transport for local process communication\n- HTTP/SSE transport for 2024-11-05 compatibility\n- Streamable HTTP transport for 2025-03-26 support\n\n#### Phase 3: Feature Implementations\n\n- Resources management and subscription\n- Tools registration and invocation\n- Prompts template system\n- Logging and telemetry\n- Authorization framework","ref":"roadmap.html#2-server-implementation-q3-q4-2025"},{"type":"extras","title":"3. Sample Implementations and Integration Examples (Q4 2025+) - Hermes MCP Roadmap","doc":"Once both client and server implementations are stable, we plan to provide:\n\n- Reference server implementations\n- Sample integration with Elixir ecosystem libraries\n- Example applications demonstrating MCP use cases\n- Integration with popular AI frameworks and platforms","ref":"roadmap.html#3-sample-implementations-and-integration-examples-q4-2025"},{"type":"extras","title":"Feature Backlog - Hermes MCP Roadmap","doc":"Beyond the core roadmap, we maintain a backlog of features for future consideration:\n\n- **WebSockets Transport**: Alternative transport layer for bidirectional communication\n- **Observability**: Advanced telemetry and monitoring integration\n- **Rate Limiting and Quota Management**: For server implementations\n- **Testing Tools**: Extended tools for protocol testing and validation","ref":"roadmap.html#feature-backlog"},{"type":"extras","title":"Contributing - Hermes MCP Roadmap","doc":"We welcome contributions to any part of this roadmap. See [CONTRIBUTING.md](./CONTRIBUTING.md) for details on how to get involved.\n\nIssues are tracked in GitHub and tagged with milestone information. For current development priorities, see our [open issues](https://github.com/cloudwalk/hermes-mcp/issues).","ref":"roadmap.html#contributing"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}